#-------------------------------------------------------------------------------
#
# TAKUJI HATAKAWA(TAK2HATA)
# mr_penta[at]hotmail[dot]com
#
#-------------------------------------------------------------------------------

require 'sketchup.rb'
require 'extensions.rb'

#-------------------------------------------------------------------------------

module TAK2HATA
  module BuildingStrcutureTool
  
  ### CONSTANTS ### ------------------------------------------------------------
  
  # Plugin information
  PLUGIN          = self
  PLUGIN_ID       = 'Building_Structure_Tool'
  PLUGIN_NAME     = 'Building_Structure_Tool'
  PLUGIN_VERSION  = '1.9.7'
  
  # Resource paths
  FILENAMESPACE = File.basename( __FILE__, '.rb' )
  PATH_ROOT     = File.dirname( __FILE__ )
  PATH          = File.join( PATH_ROOT, FILENAMESPACE )

  ### EXTENSION ### ------------------------------------------------------------
  
  unless file_loaded?( __FILE__ )
    loader = File.join( PATH, 'main.rb' )
    @ex = SketchupExtension.new( PLUGIN_NAME, loader )
    @ex.description = 'Drawing Building Structure with information from list that created by users.v1.9.7'
    @ex.version     = PLUGIN_VERSION
    @ex.copyright   = 'TAKUJI HATAKWA © 2011—2013'
    @ex.creator     = 'TAK2HATA (kurohoppie@gmail.com)'
    Sketchup.register_extension( @ex, true )
  end
  
  def self.extension
    @ex
  end
  
  end # module 
end # module

#-------------------------------------------------------------------------------

file_loaded( __FILE__ )

#-------------------------------------------------------------------------------