## Query Attribute
## by TAK2HATA
## Display Query of attribute.
#################
#General disclaimer
#I MAKES NO GUARANTEE OF VALIDITY about this script.
#Please use this script at your own risk.
#免責事項：このスクリプトによって如何なる損害が発生しても製作者は責任を負いません。各人の責任においてご使用ください。
#このスクリプトの著作権はTAK2HATAにあるものとします。
#ただし商用（販売など）の目的でない場合はご自由にお使いください。
#改変も自由ですが、配布の際はTAK2HATAまでご連絡ください。下記にブログのアドレスを掲示します。
# http://ameblo.jp/onigiri-burning/
#改変開発者の方へ：デフォルト値保存やクラス名など、名称が被らないようにご配慮お願いいたします。
#################
## 2011.11.08
## 2011.11.10 improved.Display selecting object.
## 2012.10.02 This become be included in BST.
## 2013.03.09 bug fix.and display bst info on screen.
require 'building_structure_tool/tst1_mod_common_util.rb'
module TAK2HATA::BuildingStrcutureTool
class Query_attributes3
	include TST1_mod_common_util
	# The activate method is called when a tool is first activated.  It is not
	# required, but it is a good place to initialize stuff.
	def draw(view)
		view.drawing_color = "RED"
		@bstlist.each{|cpt,hugo,prof,ly|
			if ly.visible?
			if is_in_view( view ,cpt )
				view.draw_text( view.screen_coords( cpt ) , "#{hugo}\n#{prof}")
			end
			end
		}
	end
	def search_bst_active_group( )
		model = Sketchup.active_model
		ments = model.active_entities
		@bstlist = []
		ments.find_all{|e| ( e.kind_of? Sketchup::Group or e.kind_of? Sketchup::ComponentInstance ) and e.visible? and e.get_attribute( "BEAM_SPECS","PROFILE","") != "" }.each{|obj|
			hugo = obj.get_attribute( "BEAM_SPECS","HUGO","" )
			prof = obj.get_attribute( "BEAM_SPECS","PROFILE", "" )
			cpt = obj.bounds.center
			cpt.z = obj.bounds.max.z
			ly = obj.layer
			@bstlist.push [ cpt , hugo , prof ,ly ]
			#p hugo
		}
	end
	def is_in_view( view , pt )
		pt2d = view.screen_coords( pt )
		maxv2d = view.corner(3)
		return true if pt2d[0] < maxv2d[0] and pt2d[0] > 0 and pt2d[1] < maxv2d[1] and pt2d[1] > 0
		return false
	end
	def activate
	end
	def initialize()
		search_bst_active_group
	end
	def hide_webdialog()
		if $qattrib_wdlg
			$qattrib_wdlg.close
			$qattrib_wdlg = nil
		end
	end
	def deactivate(view)
		hide_webdialog()
	end
	def onCancel(reason, view)
		hide_webdialog()
	end
	# onMouseMove is called whenever SketchUp gets a mouse move event.  It is called
	# a lot, so you should try to make it as efficient as possible.
	def onMouseMove(flags, x, y, view)
	    # show the screen position in the VCB
	    Sketchup::set_status_text("#{x}, #{y}", SB_VCB_VALUE)
	    ph = view.pick_helper
		ph.do_pick x,y
		best = ph.best_picked
		barea = 0.0
		bvol = 0.0
		@attarr = []

	    if( best )
			sel = Sketchup.active_model.selection
			if sel[0] != best
				Sketchup.active_model.selection.clear
				Sketchup.active_model.selection.add best
			end
			
			typename = best.typename
			if typename == "Group" or typename == "ComponentInstance"
				bvol = best.volume
				if bvol <= 0
					bvol = 0
				else
					barea = 0.0
					if typename == "ComponentInstance"
						best.definition.entities.find_all{|e| e.kind_of? Sketchup::Face }.each{|fc| barea += fc.area }
					else
						best.entities.find_all{|e| e.kind_of? Sketchup::Face }.each{|fc| barea += fc.area }
					end
				end
				bname = best.name
				bdesc = best.description
			elsif typename == "Face"
				barea = best.area
			end
			#bvol = bvol * ( 0.0254 ** 3 )#m3
			#barea = barea * ( 0.0254 ** 2 )#m2平米
			skunits = Sketchup.active_model.options["UnitsOptions"]["LengthUnit"]
			#skunits inch, feet, mm, cm, m
			if skunits == 0#inch
			elsif skunits == 1#feet
				bvol = bvol * ( 0.083332 ** 3 )
				barea = barea * ( 0.083332 ** 2 )
			elsif skunits == 2#mm
				bvol = bvol * ( 25.4 ** 3 )
				barea = barea * (25.4 ** 2 )
			elsif skunits == 3#cm
				bvol = bvol * ( 2.54 ** 3 )
				barea = barea * ( 2.54 ** 2 )
			elsif skunits == 4#m
				bvol = bvol * ( 0.0254 ** 3 )
				barea = barea * ( 0.0254 ** 2 )
			end
			vunits = ["cu.in","cu.ft","mm3","cm3","m3"]
			arunits = ["sq.in","sq.ft","mm2","cm2","m2"]
			bname = "" if bname == nil
			bdesc = "" if bdesc == nil
			@attarr.push ["typename",typename]
			@attarr.push ["name",bname]
			@attarr.push ["description",bdesc]
			@attarr.push ["volume",bvol.to_s + vunits[skunits] ]
			@attarr.push ["surface_area",barea.to_s+ arunits[skunits] ]
			if typename == "Face"
				@attarr.push ["front_material",best.material.name] if best.material and best.material.name
				@attarr.push ["back_material",best.back_material.name] if best.back_material and best.back_material.name
			end
			cr = "\n"
			msg = ""
			msg << "[typename]:::" + typename + cr
			msg << "[name]:::" + bname + cr
			msg << "[description]:::" + bdesc + cr
			msg << "[volume]:::" + bvol.to_s + "m3" + cr
			msg << "[surface_area]:::" + barea.to_s + "m2" + cr
			@dicslist = []
			#@ddics = []
			get_attributes( best )
			tb = "   "
			@dicslist.each{ | caps , dics |
				dics.each{| dicname , dic |
					msg << "[#{caps} Dic]:" + dicname + cr
					dic.each{|key,val|
						msg << tb + "[#{key.to_s}]:::#{val.to_s}" + cr
						
					}
				}
			}

	        msg2 = msg.gsub(/\n/,' ')
	        Sketchup::set_status_text msg2
	        # set the tooltip to show this message

	        view.tooltip = msg
	        
	        # see if we need to update the display for this point
	        #if( changed and (@ip.display? or @displayed) )
	            # This tells the view that we want it to update itself
	        view.invalidate
	        #end
	    end
	end
	def get_attributes( ent )
		dics = []
		ddics = []
		if ent.attribute_dictionaries != nil
			ent.attribute_dictionaries.each{|dic|
				dics.push [ dic.name ,dic ]
			}
		end
		if ent.kind_of? Sketchup::ComponentInstance
			if ent.definition.attribute_dictionaries != nil
			ent.definition.attribute_dictionaries.each{|dic|
				ddics.push [dic.name ,dic ]
			}
			end
		end
		@dicslist = [ [ "Instance" , dics ] , [ "Definition" , ddics ] ]
	end#def copy attributes

	# onLButtonDown is called when the user presses the left mouse button
	def onLButtonDown(flags, x, y, view)
		#jqlibpath = File.dirname( __FILE__ )
		jqlibpath = bst_file_dirname( __FILE__ )
		cr = "\n"
		#wdlgpath = File.join( jqlibpath , "query_attributes.html" )

		##fs = open( wdlgpath , "w+" )
		#fs = nil
		
		##if fs
		##	jqlibpath = ""
		##else
		##	jqlibpath.gsub!(/\\/,"/")
		##end
sml = '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN">
<html lang="ja"><head><meta http-equiv="content-type" content="text/html; charset=UTF-8" />
<link rel="stylesheet" type="text/css" media="screen" href="' + jqlibpath + '/css/south-street/jquery-ui-1.7.3.custom.css" />
<link rel="stylesheet" type="text/css" media="screen" href="' + jqlibpath + '/css/ui.jqgrid.css" />
<script type="text/javascript" src="' + jqlibpath + '/js/jquery-1.8.2.min.js"></script>
<script type="text/javascript" src="' + jqlibpath + '/js/jquery-ui-1.8.24.custom.min.js"></script>
<script type="text/javascript" src="' + jqlibpath + '/js/i18n/grid.locale-ja.js" ></script>
<script type="text/javascript" src="' + jqlibpath + '/js/jquery.jqGrid.min.js" ></script>
<script type="text/javascript">
 	jQuery(document).ready(function()
	{
		var gridprot = {
			datatype: "local",
			colNames:["NAME", "VALUE1"],
			colModel:[
				{index:"name", name:"name", width:100,editable:false ,sortable:false}, 
				{index:"value1", name:"value1", width:200,editable:false ,sortable:false},
			],
			beforeEditCell: function (rowid, cellname, value, iRow, iCol) {
				// クリックされたセルを記録
				savedRow = iRow;
				savedCol = iCol;
			},
			cellEdit: true,    // true: クリックしたセルの編集
			cellsubmit: "clientArray",
			//scroll:true,
			viewrecords: true,
			hiddengrid: false,
			height:"auto"
		};
'

dname = []
dcount = 0
dname[dcount] = "main_query"
sml << 'var ' + dname[dcount] + ' = [' + "\n"
smlarr = []
@attarr.each{|key,val|
	smlarr.push '{name:"' + key.to_s.gsub(/\"/,"&quot;") + '",value1:"' + val.to_s.gsub(/\"/,"&quot;") + '"}'
}
sml << smlarr.join(",\n") + "\n"
sml << '];
		gridprot.caption = "' + dname[dcount] + '";
		gridprot.data = ' + dname[dcount] + ';
		jQuery("#' + dname[dcount] + '").jqGrid( gridprot );
		var hoge ={};' + "\n"
@dicslist.each{| caps , dics |
	dics.each{| dicname , dic |
		dcount += 1
		dname[dcount] = dicname.strip.gsub(/[\#\"\'\!\\]+/,"_")
		dname[dcount] = "ATTRIBUTE-#{dcount}"if dname[dcount] == ""
		sml << 'hoge["' + dname[dcount].gsub(/\"/,"&quot;") + '"] = [' + "\n"
		smlarr = []
		
		dic.each{|key , val|
			smlarr.push '{name:"' + key.to_s.gsub(/\"/,"&quot;") + '",value1:"' + val.to_s.gsub(/\"/,"&quot;") + '"}'
		}
		sml << smlarr.join(",\n") + "\n"
		sml << '];
			gridprot.caption = "' + caps + ' Dictionary:' + dicname.gsub(/\"/,"&quot;") + '";
			gridprot.data = hoge["' + dname[dcount].gsub(/\"/,"&quot;") + '"];
			jQuery("#' + dname[dcount].gsub(/\"/,"&quot;") + '").jqGrid( gridprot );' + "\n"
	}
}
dcount += 1
sml << '	});
</script>
</head><body scroll=yes>
<form name="frm_attribute" >' + "\n"
dcount.times{|i|
sml << '<table id="' + dname[i] + '"></table>' + "\n"
}
sml << '</form>
</body></html>' + cr
		prfkeys = { 
			:dialog_title => 'QueryAttributes3', 
			:scrollable => true, 
			:preferences_key => 'QueryAttributes3', 
			:height => 550, 
			:width => 375, 
			:left => 150, 
			:top => 150, 
			:resizable => true, 
			:mac_only_use_nswindow => true
		} 
		$qattrib_wdlg.close if $qattrib_wdlg
		$qattrib_wdlg = UI::WebDialog.new( prfkeys )
		$qattrib_wdlg.set_on_close{
			$qattrib_wdlg = nil
		}
		#if fs
		#	p "show webdialog by FILE"
		#	fs.puts( sml )
		#	fs.close
		#	$qattrib_wdlg.set_file( wdlgpath )
		#	sml = nil
		#else
			p "show webdialog by CODE"
			$qattrib_wdlg.set_html( sml )	##変更箇所
		#end

		if RUBY_PLATFORM[/darwin/]
			$qattrib_wdlg.show_modal
		else
			$qattrib_wdlg.show
		end
	end

	# onLButtonUp is called when the user releases the left mouse button
	def onLButtonUp(flags, x, y, view)
	    #Sketchup::set_status_text $uStrings.GetString("Left button up at") + " (#{x}, #{y})"
	end

	# draw is optional.  It is called on the active tool whenever SketchUp
	# needs to update the screen.
	# in this case, we display an input point if needed

end
end#module
#-----------------------------------------------------------------------------
# Make selected components unique.
# This looks at all selected components.
=begin
def make_selected_components_unique

    # First get all selected components
    ss = Sketchup.active_model.selection
    components = ss.find_all {|e| e.kind_of?(Sketchup::ComponentInstance) }
    
    # Create a Hash.  The keys are the guids of all of the component definitions
    # for selected components.  The values are arrays of all of the component instances
    # that have that definition
    definitions = {}
    for component in components
        key = component.definition.guid
        a = definitions[key]
        if( a )
            a.push component
        else
            definitions[key] = [component]
        end
    end
    
    # Now make each collection of component instances have a new unique definition
    definitions.each_value do |a|
        # a is an array of component instances that all share the same definition
        # We will make the first one have a new unique definition, and all of the
        # other ones use that new definition
        definition = nil
        for component in a
            if( definition )
                # We already have a new definition.  Make this component use it
                component.definition = definition
            else
                # Make the component have a unique definition and save it
                component.make_unique
                definition = component.definition
            end
        end
    end

    true
end
=end

#----------------------------------------------------------------------------
# Add things to the Utilities menu
#unless( file_loaded?( File.basename(__FILE__) ) )
#	menuitem = "QueryAttributes"
#	menuitem = "属性表示" if @lang == "JA" or @lang == "JP"

#    UI.menu("Plugins").add_item( menuitem ) { Sketchup.active_model.select_tool Query_attributes3.new }

#end
#file_loaded(File.basename(__FILE__))