require 'sketchup.rb'
require 'building_structure_tool/tst1_mod_create_geometry.rb'
require 'building_structure_tool/tst1_mod_dialog.rb'
require 'building_structure_tool/tst1_mod_common_util.rb'
module TAK2HATA::BuildingStrcutureTool
class TST1_class_replacer
	include TST1_mod_create_geometry
	include TST1_mod_chamfer
	include TST1_mod_dialog
	include TST1_mod_common_util
	def tst_prof_replace_start( bclass= "STEEL_BEAM" )
		model = Sketchup.active_model
		sels = model.selection
		bsts = []
		sels.each{|sel|
			if sel.kind_of? Sketchup::ComponentInstance or sel.kind_of? Sketchup::Group
				att_crv = sel.get_attribute( "BEAM_SPECS","CURVE" )
				if att_crv != nil
					bsts.push sel
				end
			end
		}
		if bsts != []
			
			specs = startDialogSelect( bclass )
			beams_just,beams_vjust,beams_axis,beams_spec,beams_mirz,beams_fixz,beams_top,beams_height,beams_rot,wall_width = specs
			if Sketchup.version.to_f < 7.0
				Sketchup.active_model.start_operation "replace structure"
			else
				Sketchup.active_model.start_operation "replace structure",true
			end
			bsts.each{|bstent|
				bstent.make_unique
				tgr = bstent.transformation
				pts = bstent.get_attribute( "BEAM_SPECS","PATH",[] )
				if pts == []
					bstent.entities.each{|e|
						if e.typename == "ConstructionLine"
							pts[0] = e.start
							pts[1] = e.end
						end
					}
				end
				drawStructure( pts , beams_spec , beams_just , beams_vjust , beams_axis , beams_top , beams_rot , beams_mirz , wall_width , beams_height , nil , tgr )
			}
			bsts[0].parent.entities.erase_entities bsts
			Sketchup.active_model.commit_operation
		end
	end

end#class
end#module