require 'sketchup.rb'
require 'building_structure_tool/tst1_mod_create_geometry.rb'
require 'building_structure_tool/tst1_mod_dialog.rb'
require 'building_structure_tool/tst1_mod_common_util.rb'
require 'building_structure_tool/tst1_mod_toolclass.rb'
module TAK2HATA::BuildingStrcutureTool
class TST1_class_tool
		include TST1_mod_create_geometry
		include TST1_mod_chamfer
		include TST1_mod_dialog
		include TST1_mod_common_util
		include TST1_mod_toolclass
		def initialize( bclass = "STEEL_BEAM" )
			@bclass = bclass
			@pwall = nil
			##@units = "mm"
			#Sketchup.active_model.layers.add "Structure-#{@bclass}"
		end
        def activate
            @ip  = Sketchup::InputPoint.new
            @ip1 = Sketchup::InputPoint.new
            @ip2 = Sketchup::InputPoint.new
            Sketchup.active_model.active_view.lock_inference
            self.reset(nil)
            @drawn = false
			
			specs = startDialogSelect( @bclass )
			
			sel = Sketchup.active_model.selection
			sellines = sel.find_all{|e| e.kind_of?( Sketchup::Edge ) or e.kind_of?( Sketchup::ConstructionLine )}
			if not sellines == [] #sel.empty?
				if sellines.size != 0
					msg = langconv( "Auto Create from selected edges(and clines)?" ) + ":(#{sellines.size})"
					sel_res = nil
					sel_res = UI.messagebox msg , MB_YESNO
					if sel_res == 6#res YES
						#auto_create_from_lines sellines
						auto_create_from_lines( @bclass , @beams_spec , @beams_just , @beams_vjust , @beams_axis , @beams_top , @beams_rot , @beams_mirz , @wall_width , @beams_height , sellines )
						Sketchup.active_model.select_tool nil
					end
				end
			end
			Sketchup::set_status_text "#{langconv( 'First Point or Search word:Current')} #{@beams_spec}|#{@beams_just}|#{@beams_vjust}|#{langconv('TOP')}= #{@beams_top}|#{langconv( 'AXIS')}? #{@beams_axis}|#{langconv('HEIGHT')}=#{@beams_height}|#{langconv( 'rotate')}=#{@beams_rot}"
            Sketchup::set_status_text "", SB_VCB_VALUE
        end
end#class
end#module