#Oct 28,2012:Update:Bugfix about MWALL and SHAPES and AXIS inference.
#Dec 04,2012.Update:Bug fix.about Drawing in group.
#Feb 19,2013:modified.
require 'sketchup.rb'
require 'building_structure_tool/tst1_mod_create_geometry.rb'
require 'building_structure_tool/tst1_mod_common_util.rb'
require 'building_structure_tool/tst1_mod_bst_propery_man_dummy.rb'

require 'building_structure_tool/tst1_mod_extend_to_structure.rb'
require 'building_structure_tool/tst1_mod_chamfer.rb'
require 'building_structure_tool/tst1_mod_extend_to_face.rb'
require 'building_structure_tool/tst1_mod_click_two_bst_entity.rb'
require 'building_structure_tool/tst1_mod_grow_to_face.rb'
require 'building_structure_tool/tst1_mod_grow_to_structure.rb'
module TAK2HATA::BuildingStrcutureTool
class TST1_class_extend_str
	include TST1_mod_common_util
	include TST1_mod_click_two_entity
	include TST1_extend_structures
end
class TST1_class_chamfer
	include TST1_mod_common_util
	include TST1_mod_click_two_entity
	include TST1_mod_chamfer
end
class TST1_class_extend_face
	include TST1_mod_common_util
	include TST1_mod_click_two_entity
	include TST1_mod_extend_to_face
end
class TST1_class_grow_face
	include TST1_mod_common_util
	include TST1_mod_click_two_entity
	include TST1_mod_grow_to_face
end
class TST1_class_grow_str
	include TST1_mod_common_util
	include TST1_mod_click_two_entity
	include TST1_mod_grow_to_str
end
class TST1_class_tool_for_wdlg_main
		include TST1_mod_create_geometry
		include TST1_mod_chamfer
		include TST1_mod_common_util
		def show_states_text()
            if @state == 0
				if @bclass == "RC_SLAB"
					Sketchup::set_status_text langconv( "Click point to Hit Area.:[Esc]=Quit" )
				else
					Sketchup::set_status_text langconv( "First point:[Esc]=Quit" )
				end
			else
				Sketchup::set_status_text langconv("Next point:[Esc]=Quit")
            end
		end
		def initialize( btdlg )
			$bst_tool_wdlg = btdlg
			get_All_Properties( $bst_tool_wdlg )
			@pwall = nil
			@first_point = nil
			@first_wall = nil
			##$bst_parts_units = "mm"
			#Sketchup.active_model.layers.add "Structure-#{@bclass}"
		end
        def activate
            @ip  = Sketchup::InputPoint.new
            @ip1 = Sketchup::InputPoint.new
            @ip2 = Sketchup::InputPoint.new
            Sketchup.active_model.active_view.lock_inference
            self.reset(nil)
            @drawn = false

			show_states_text()
			Sketchup::set_status_text "", SB_VCB_VALUE
        end
        def reset(view)
            @pts              = []
            @shape_pts         = []
            @state            = 0
            @drawn            = false
            @ip.clear
            @ip1.clear
            @ip2.clear
			show_states_text()
            view.lock_inference if view
        end
        def reset2(view)
			pt = @pts[1]
			if view
                if( view.inference_locked? )
					trrot = Geom::Transformation.rotation( Geom::Point3d.new( 0,0,0 ) , Geom::Vector3d.new( 0,0,1 ) , 90.degrees )
					vec = pt.vector_to( @pts[0] ).transform( trrot )
					trvec = Geom::Transformation.translation( vec )
					pt2 = pt.transform( trvec )
                    view.lock_inference Sketchup::InputPoint.new( pt2 ) , Sketchup::InputPoint.new( pt )
                end
                view.invalidate
			end
			@ip1 = Sketchup::InputPoint.new( pt )
            @pts = []
			@pts.push pt
            @shape_pts         = []
            @state            = 1
            @drawn            = false
            @ip.clear
            @ip2.clear
            show_states_text()
        end
        def resume(view)
            show_states_text()
        end
        def deactivate(view)
            view.invalidate if @drawn
        end

        def onCancel(flag, view)
            # Clean view and exit the tool
            view.invalidate if @drawn
			if ( @bclass == "RC_WALL" or @bclass == "MWALL" ) and @state == 1
				@pgeom = nil
				self.reset(view)
			else
				Sketchup.active_model.select_tool nil
			end
        end

        def onReturn(view)
            # Clean view and exit the tool
            view.invalidate if @drawn
            self.reset(view)
            Sketchup.active_model.select_tool nil
		end
		
        def drawBeam(view)
			#get_All_Properties( $bst_tool_wdlg )
			#pgeom = self.create_geometry( @bclass , @pts , @beams_spec , @beams_just , @beams_vjust , @beams_axis , @beams_top , @beams_rot , @beams_mirz , @wall_width , @beams_height , @pgeom)
			operation_name = "draw structure"
			if Sketchup.version.to_f < 7.0
				Sketchup.active_model.start_operation operation_name
			else
				Sketchup.active_model.start_operation operation_name,true
			end
			pgeom = self.create_geometry2( @pts , @beams_props , @pgeom )
			Sketchup.active_model.commit_operation
			@pgeom = pgeom
			if @bclass == "RC_WALL" or @bclass == "MWALL"
				self.reset2(view)
			else
				self.reset(view)
			end
		end

        def onRButtonDown(flags, x, y, view)
            dialog()
            view.invalidate
			#onReturn(view)
        end

        def onUserText(text, view)
            ##if @state == 0
                # enter hariHugo
                #dialog text
            ##end
			
            return if not @state == 1
            return if not @ip2.valid?

                begin
                    value = text.to_l
                rescue
                    # Error parsing the text
                    UI.messagebox( "#{text} " + langconv( "cannot convert to a Length" ) )
                    value = nil
                    Sketchup::set_status_text "", SB_VCB_VALUE
                end
            return if !value
			#end
            # Compute the direction and the second point
            if ( @state == 1 )            
	            #pt1 = @ip1.position
				pt2 = @ip2.position
				pt2.z = @beams_fixz if @beams_fixz_chk == true
				vec = @pts[0].vector_to(pt2)
                if vec.length == 0.0
	                UI.messagebox( langconv("Zero length invalid !") )
	                return
	            end
	            vec.length = value
	            pt2 = @pts[0] + vec
	            # Store point
	            @pts.push(pt2)

            	#@ip1 = Sketchup::InputPoint.new( @pts[1] )
				drawBeam( view )
            end
            view.invalidate
        end

        def onMouseMove(flags, x, y, view)
            if( @state == 0 )
                show_states_text()
                # Getting the first end
                @ip.pick view, x, y
                if( @ip != @ip1 )
                    # if the point has changed from the last one we got
                    view.invalidate if( @ip.display? or @ip1.display? )
                    @ip1.copy! @ip
                    # set the tooltip that should be displayed to this point
                    view.tooltip = @ip1.tooltip
                end
            else
                # Getting the next end
				show_states_text()
                Sketchup::set_status_text langconv("LENGTH"), SB_VCB_LABEL
                @ip2.pick view, x, y, @ip1

                # Update the length displayed in the VCB
                if( @ip2.valid? )
                    length = @ip1.position.distance(@ip2.position)
                    Sketchup::set_status_text length.to_s, SB_VCB_VALUE
                end

                view.tooltip = @ip2.tooltip if( @ip2.valid? )
                view.invalidate
            end
        end
        def onLButtonDown(flags, x, y, view)
			get_All_Properties( $bst_tool_wdlg )
            if ( @state == 0 )
                if( @ip1.valid? )
                    @pts.push(@ip1.position)
					@pts[0].z = @beams_fixz if @beams_fixz_chk == true
					fc1 = @ip1.face
					apath = Sketchup.active_model.active_path
					exist_entity = false
					if fc1
						if fc1.parent.kind_of? Sketchup::Model
						elsif apath != nil and fc1.parent.group?
							fc1.parent.instances.each{|igrp|
								if fc1.parent.entityID == apath[apath.size-1].entityID
									exist_entity = false
									break
								else
									exist_entity = true
								end
							}
						end
					end
					@ip1 = Sketchup::InputPoint.new( @pts[0] )
					if @bclass == "STEEL_COLUMN" or @bclass == "RC_COLUMN"
						@pts.push( [ @pts[0].x , @pts[0].y , @pts[0].z + @beams_height ] )
						drawBeam( view )
					elsif @bclass == "RC_FOOTING"
						@pts.push( [ @pts[0].x , @pts[0].y , @pts[0].z + 1000.mm ] )
						drawBeam( view )
					elsif @bclass == "SLAB"
						pt = @ip.position.clone
						camera = view.camera
						line1 = [ pt , camera.eye ]
						plane1 = [ Geom::Point3d.new( 0,0,@slab_hitlevel ) ,  Geom::Vector3d.new( 0,0,1 ) ]
						intpt = Geom.intersect_line_plane(line1, plane1)
						
						return if intpt == nil
						if camera.eye.distance( intpt ) > camera.eye.distance( pt )
							slab_from_face( view , fc1 ,  x, y ) if fc1
						elsif camera.eye.distance( intpt ) == camera.eye.distance( pt ) and fc1
							#実際にクリックした点と仮想平面上のクリック点が同一の場合そこにすでに何かあるということになる。
							#それが作業グループに属する単なる面であればスラブを発生させる
							slab_from_face( view , fc1 ,  x, y )
						elsif camera.eye.distance( intpt ) == camera.eye.distance( pt ) and exist_entity == true
							p "here exist entity"
						else
							p "slab from clicking point"
							slab_hitlv = @slab_hitlevel
							dzs = [ 0 , -1.mm , 1.mm ]
							chk = false
							dzs.each{|dz|
								@slab_hitlevel = slab_hitlv + dz
								plane1 = [ Geom::Point3d.new( 0,0, @slab_hitlevel ) ,  Geom::Vector3d.new( 0,0,1 ) ]
								intpt = Geom.intersect_line_plane(line1, plane1)		
								chk = create_slab_withPT( intpt , plane1 )
								break if chk != false
							}
							if chk == false and fc1
								#作成がうまくいかなかった場合
								slab_from_face( view , fc1 ,  x, y )
							end
							@slab_hitlevel = slab_hitlv
							reset(view)
						end
					else
						@state+=1
					end
                end
            end
            if ( @state == 1 )
                #check next point
                if( @ip2.valid? )
					pt2 = @ip2.position
					pt2.z = @beams_fixz if @beams_fixz_chk == true
                    if @pts[0].vector_to(pt2).normalize.length > 0
						if( @bclass == "RC_WALL" or @bclass == "MWALL" ) and @pts[0].vector_to(pt2).parallel?(Geom::Vector3d.new( 0,0,1 ))
						else
							@pts.push(pt2)
							drawBeam( view )
						end
					end
                end
            end
            view.invalidate
        end
        def slab_from_face( view , fc1 , x , y )
			ifc = fc1
			ph = view.pick_helper
			ph.do_pick x,y
			pe = ph.best_picked
			camera = view.camera
			if pe and pe.entityID == ifc.entityID
				p "slab from face"
				createSlabFromFace( ifc )
				reset(view)
			else
				reset(view)
				return
			end
		end
        # Draw temp line between ends of partition axis
        def draw_temp_line(pt1, pt2, view)
            #view.drawing_color = "red"
            view.set_color_from_line(pt1, pt2)
            #view.line_stipple="-.-"
            if view.inference_locked?
                view.line_width=2
            end
            @bbp = [pt1, pt2]
            view.draw_line(pt1, pt2)
        end

        def getExtents
            bb = Geom::BoundingBox.new
            #bb.aptsdd(pt) if pt
            if @bbp
            @bbp.each { |pt| bb.add(pt) }
            end
            bb
        end

        def onKeyDown(key, rpt, flags, view)
            if( key == CONSTRAIN_MODIFIER_KEY )
                # if we already have an inference lock, then unlock it
                if( view.inference_locked? )
					p "-locked"
                    view.lock_inference
                elsif( @state == 1 )
					p "state1"
                    ##view.lock_inference @ip2, @ip1##110909
                    view.lock_inference @ip2 , @ip1
                else
					p "stateelse"
                    view.lock_inference @ip2
                end
                view.invalidate
            end
        end

        def onKeyUp(key, rpt, flags, view)
            if( key == CONSTRAIN_MODIFIER_KEY && view.inference_locked? )
                #(Time.now - @shift_down_time) > 0.5 )
                view.lock_inference
            end
            if key == 9 # or key == 15 or key == 48 # Tab key (according to TIG) ?
                dialog()
            end
            view.invalidate
        end
		
        def draw(view)
            # Show input points when valid
            if( @ip1.valid? )
                if( @ip1.display? )
                    @ip1.draw(view)
                    #@drawn = true
                end  
                if( @ip2.valid? )
                    @ip2.draw(view) if( @ip2.display? )
                    self.draw_temp_line(@ip1.position, @ip2.position, view) if (@ip1.valid? and @ip2.valid?)
                    #@drawn = true
                end
            end
            # Show the previously drawn axis
            #self.draw_previous_points(view)
            @drawn = true
        end

end
class TST1_class_tool_for_wdlg
		include TST1_mod_create_geometry
		include TST1_mod_chamfer
		include TST1_mod_common_util
		include TST1_mod_bst_propery_man_dummy
		def read_classdefaults
			@wall_width = 100.mm
			@beams_fixz = 0
			@beams_spec = ""
			@beams_top = 0.0
			@beams_height = 1000.mm
			@beams_rot = 0.0
			@beams_mirz = "No"
			@beams_axis = "Yes"
			if @bclass == "STEEL_COLUMN" or @bclass == "RC_COLUMN"
				@beams_just   = "Center"
				@beams_vjust   = "Middle"
			elsif @bclass == "RC_WALL"
				@beams_just   = "Center"
				@beams_vjust   = "Bottom"
			elsif @bclass == "MWALL"
				@beams_just   = "Center"
				@beams_vjust   = "Bottom"
			else
				@beams_just   = "Center"
				@beams_vjust   = "Top"
			end
			
			if @bclass != "SLAB"
				defaults = Sketchup.read_default("Structure Tool", "#{@bclass}:params")
				if not defaults
					tst_clear_class_default(@bclass)
					defaults = Sketchup.read_default("Structure Tool", "#{@bclass}:params")
				end
				if defaults
					results = eval( defaults )
					@beams_just   = results[0] if results.size > 0
					@beams_vjust   = results[1] if results.size > 1
					#@beams_axis   = results[2] if results.size > 2
					##@beams_axis is allways YES
					@beams_spec   = results[3] if results.size > 3
					@beams_mirz = results[4] if results.size > 4
					#p results[5]
					@beams_fixz = results[5].to_f.to_l if results.size > 5 
					#p results[6]

					@beams_top = results[6].to_f.to_l if results.size > 6
					#p results[7]
					@beams_height = results[7].to_f.to_l if results.size > 7
					@beams_rot = getNumeric( results[8] ) if results.size > 8
					#p results[9]
					@wall_width = results[9].to_f.to_l if results.size > 9
					@profile = results[10] if results.size > 10
					#p results[11] if results.size > 11
					fixz_chk = results[11] if results.size > 11
					#if @beams_fixz != ""
						@beams_fixz_chk = false
						@beams_fixz_chk = true if fixz_chk == "true"
						#@beams_fixz = beams_fixz.to_l
					#end
					#p @beams_fixz.to_s.split("'").join( "' + \"'\" + '") 
					$bst_tool_wdlg.execute_script("document.getElementById('BST_FIXZ').value='" + @beams_fixz.to_s.split("'").join( "' + \"'\" + '") + "'" )
					if @beams_fixz_chk == true
						$bst_tool_wdlg.execute_script('document.getElementById("CHK_FIXZ").value="true"')
						$bst_tool_wdlg.execute_script('document.getElementById("CHK_FIXZ").checked=true')
						
					else
						$bst_tool_wdlg.execute_script('document.getElementById("CHK_FIXZ").value="false"')
						$bst_tool_wdlg.execute_script('document.getElementById("CHK_FIXZ").checked=false')
						
					end
					if @beams_mirz == "Yes"
						$bst_tool_wdlg.execute_script('document.getElementById("CHK_MIRR").value="true"')
						$bst_tool_wdlg.execute_script('document.getElementById("CHK_MIRR").checked=true')
					else
						$bst_tool_wdlg.execute_script('document.getElementById("CHK_MIRR").value="false"')
						$bst_tool_wdlg.execute_script('document.getElementById("CHK_MIRR").checked=false')
					end
					#p @beams_height.to_s.split("'").join( "' + \"'\" + '") 
					$bst_tool_wdlg.execute_script( "document.getElementById('BST_HEIGHT').value='" + @beams_height.to_s.split("'").join( "' + \"'\" + '") + "'" )
					#p @wall_width.to_s.split("'").join( "' + \"'\" + '") 
					$bst_tool_wdlg.execute_script( "document.getElementById('BST_WIDTH').value='" + @wall_width.to_s.split("'").join( "' + \"'\" + '") + "'" )
					#p @beams_rot.to_s.split("'").join( "' + \"'\" + '") 
					$bst_tool_wdlg.execute_script( "document.getElementById('BST_ROTATE').value='" + @beams_rot.to_s.split("'").join( "' + \"'\" + '") + "'" )
					v = 3 if @beams_just == "Left"
					v = 2 if @beams_just == "Center"
					v = 1 if @beams_just == "Right"
					v = v + 3 if @beams_vjust == "Middle"
					v = v + 6 if @beams_vjust == "Top"
					$bst_tool_wdlg.execute_script('document.getElementById("jst' + v.to_s + '").checked=true')
					$bst_tool_wdlg.execute_script('document.getElementById("BST_JUST").value="' + v.to_s + '"')
				end
			else
				sl_defaults = Sketchup.read_default("Structure Tool", "SLAB:params" )
				if not sl_defaults
					tst_clear_class_default("SLAB")
					sl_defaults = Sketchup.read_default("Structure Tool", "SLAB:params")
				end
				if sl_defaults
					sl_results = eval( sl_defaults )
					@slab_toplevel = sl_results[1].to_l if sl_results.size > 1
					@slab_hitlevel = sl_results[2].to_l if sl_results.size > 2
					@slab_hitrange = sl_results[3].to_l if sl_results.size > 3
					#p @slab_toplevel.to_s.split("'").join( "' + \"'\" + '")
					$bst_tool_wdlg.execute_script("document.getElementById('BST_GENLEVEL').value='" + @slab_toplevel.to_s.split("'").join( "' + \"'\" + '") + "'" )
					$bst_tool_wdlg.execute_script("document.getElementById('BST_CLICKLEVEL').value='" + @slab_hitlevel.to_s.split("'").join( "' + \"'\" + '") + "'" )
					$bst_tool_wdlg.execute_script("document.getElementById('BST_CLICKRANGE').value='" + @slab_hitrange.to_s.split("'").join( "' + \"'\" + '") + "'" )
				end
			end
		end
		def save_classdefault()
			
			bclass = Sketchup.read_default("Structure Tool", "WDLG_CLASS","ALL")
			#p "save default#{bclass}"
			get_All_Properties( $bst_tool_wdlg )
			results = []
			@bclass = bclass if bclass != nil
			if @bclass != "SLAB"
				results[0] = @beams_just
				results[1] = @beams_vjust
				results[2] = "Yes"
				results[3] = @beams_profile
				results[4] = @beams_mirz
				results[5] = @beams_fixz
				results[6] = @beams_top
				results[7] = @beams_height
				results[8] = @beams_rot
				results[9] = @wall_width
				results[10] = @profile
				results[11] = "false"
				results[11] = "true" if @beams_fixz_chk == true
				Sketchup.write_default("Structure Tool", "#{@bclass}:params", results.inspect.gsub( 34.chr , "'"))
			else
				results[0] = ""
				results[1] = @slab_toplevel
				results[2] = @slab_hitlevel
				results[3] = @slab_hitrange
				results[4] = @profile
				Sketchup.write_default("Structure Tool", "SLAB:params", results.inspect.gsub( 34.chr , "'"))
			end
		end
		def read_mwalls()
			pflist = []

			#pfolder = File.expand_path( File::dirname( bst_u8tosjis( Sketchup.find_support_files( "", "Plugins" )[0] ) ) )
			#pdir = File.join( File.dirname( File.expand_path(__FILE__) ),"mwalls","*.skp" )
			pdir = bst_file_join( bst_file_dirname( __FILE__ ),"mwalls","*.skp" )
			#File.join( pfolder , "building_structure_tool","mwalls","*.skp" )
			Dir::glob( pdir ).each {|f|
				##pflist.push ",#{File.basename(f)},,,,,,,,,".gsub(/\,/,"\t")
				pflist.push ",#{bst_file_basename(f)},,,,,,,,,".gsub(/\,/,"\t")
			}
			pflist_path = pdir
			return pflist , pflist_path
		end
		def read_shapes()
			pflist = []

			#pfolder = File.expand_path( File::dirname( bst_u8tosjis( Sketchup.find_support_files( "", "Plugins" )[0] ) ) )
			#pdir = File.join( File.dirname( File.expand_path(__FILE__) ),"shapes","*.skp" )
			pdir = bst_file_join( bst_file_dirname( __FILE__ ),"shapes","*.skp" )
			#File.join( pfolder , "building_structure_tool","shapes","*.skp" )
			Dir::glob( pdir ).each {|f|
				##pflist.push ",[SHAPE]#{File.basename(f,'.*')},,,,,,,,,".gsub(/\,/,"\t")
				pflist.push ",[SHAPE]#{bst_file_basename(f,'.*')},,,,,,,,,".gsub(/\,/,"\t")
			}
			pflist_path = pdir
			return pflist , pflist_path
		end
		def init_webdialog( bclass = "" , chkword = true )
			bclass = Sketchup.read_default("Structure Tool", "WDLG_CLASS","ALL") if bclass == ""
			sword = Sketchup.read_default("Structure Tool", "searchword","")
			if bclass == "ALL" and chkword == true
				prompts = [langconv( "Search Word?(BLANK to ALL)" )]
				defaults = [sword]
				results = UI.inputbox prompts, defaults, langconv( "Start from searching with Words?" )
				if results != nil and results != false
					sword = results[0]
					Sketchup.write_default("Structure Tool", "searchword",sword)
				end
			end
			jcmd = 'selectListbox("BST_CLASS","' + bclass + '")'
			$bst_tool_wdlg.execute_script(jcmd)
			sword = "" if bclass != "ALL" or chkword == false
			pflisthash , pflist_path = readProfiles(bclass,sword)
			pflist = pflisthash[bclass]
			
			if bclass == "MWALL"
				pflist , pflist_path = read_mwalls()
			elsif bclass == "SHAPES"
				pflist , pflist_path = read_shapes()
			end
			addliststr = []
			addliststr.push "var str ='"
			addliststr.push '<select name="BST_SPECS" id="BST_SPECS" size="8" style="width:350px;" onChange ="changedBstSpecs(this[this.selectedIndex].value); "onDblClick ="startDrawing();">'
			pflist.each{|pf|
				#addliststr.push split_csvline( pf ).join("  |  ")
				#jcmd = 'addListbox("BST_SPECS","' + split_csvline( pf ).join("  |  ") + '")'
				#$bst_tool_wdlg.execute_script(jcmd)
				#innerhtmlを使ってselectの内容を書き換えるほうが高速ですな#pfval = split_csvline( pf ).join("  |  ")
				pfval = pf.split("\t").join("  |  ").gsub(/\"/,"&quot;")
				addliststr.push '<option value="' + pfval + '">' + pfval + '</option>'

			}
			addliststr.push '</select>'
			addliststr.push "';"
			addliststr.push 'document.getElementById("BST_SPEC_DIV").innerHTML = str;'
			jcmd = addliststr.join("")
			$bst_tool_wdlg.execute_script(jcmd)
			#jcmd = 'addListbox_array("BST_SPECS","' + addliststr.join("||") + '")'
			#$bst_tool_wdlg.execute_script(jcmd)
			#document.getElementById('BST_SPECS');
			#p "リストの更新は終了"

			Sketchup.write_default("Structure Tool", "WDLG_CLASS",bclass)
			@bclass = bclass
			read_classdefaults()
			specs = pflist[0].split(/\t/).join("  |  ")
			jcmd = 'selectListbox("BST_SPECS","' + specs + '")'
			#p jcmd
			$bst_tool_wdlg.execute_script(jcmd)
			#p specs
			set_wdlg_properties( specs )
		end
		def set_wdlg_properties( specs )
			jcmd = 'changedBstSpecs("' + specs + '")'
			$bst_tool_wdlg.execute_script(jcmd)
		end
		def get_information()
			sel = Sketchup.active_model.selection
			if sel != []
				ent = sel[0]
				bname ,gtr,gmat,bclass,tag,bprofile,solid_mat,beams_rot,beams_mirz,pts,beams_just,beams_vjust,beams_top,wall_width,beams_height,sidevec,fmat,bmat,secmat = get_entity_bst_info( ent )
				#p get_entity_bst_info( ent )
				specs = [ tag , bprofile , beams_top , solid_mat , beams_rot , fmat , bmat , secmat ].join("  |  ")
				if bclass != "" and bclass != $bst_tool_wdlg.get_element_value("BST_CLASS")
					jcmd = 'selectListbox("BST_CLASS","' + bclass + '")'
					$bst_tool_wdlg.execute_script(jcmd)
					$bst_tool_wdlg.execute_script('clearAll()')
					init_webdialog( bclass , false )
				end
				
				if beams_mirz == "Yes"
					$bst_tool_wdlg.execute_script('document.getElementById("CHK_MIRR").value="true"')
					$bst_tool_wdlg.execute_script('document.getElementById("CHK_MIRR").checked=true')
				else
					$bst_tool_wdlg.execute_script('document.getElementById("CHK_MIRR").value="false"')
					$bst_tool_wdlg.execute_script('document.getElementById("CHK_MIRR").checked=false')
				end
				#$bst_tool_wdlg.execute_script('document.getElementById("BST_HEIGHT").value="' + beams_height.to_s + '"' )
				#$bst_tool_wdlg.execute_script('document.getElementById("BST_WIDTH").value="' + wall_width.to_s + '"' )
				#$bst_tool_wdlg.execute_script('document.getElementById("BST_ROTATE").value="' + beams_rot.to_s + '"' )
				$bst_tool_wdlg.execute_script( "document.getElementById('BST_HEIGHT').value='" + beams_height.to_s.split("'").join( "' + \"'\" + '") + "'" )
				$bst_tool_wdlg.execute_script( "document.getElementById('BST_WIDTH').value='" + wall_width.to_s.split("'").join( "' + \"'\" + '") + "'" )
				$bst_tool_wdlg.execute_script( "document.getElementById('BST_ROTATE').value='" + beams_rot.to_s.split("'").join( "' + \"'\" + '") + "'" )

				v = 3 if beams_just == "Left"
				v = 2 if beams_just == "Center"
				v = 1 if beams_just == "Right"
				v = v + 3 if beams_vjust == "Middle"
				v = v + 6 if beams_vjust == "Top"
				$bst_tool_wdlg.execute_script('document.getElementById("jst' + v.to_s + '").checked=true')
				$bst_tool_wdlg.execute_script('document.getElementById("BST_JUST").value="' + v.to_s + '"')

				jcmd = 'changBySpecStrings("' + specs + '")'
				#p specs
				$bst_tool_wdlg.execute_script(jcmd)
			end
		end
		def applyAllProps()
			get_All_Properties( $bst_tool_wdlg )
			tst_replaceAllProps()
		end
		def apply_one_prop( repCate , repVal )
			get_All_Properties( $bst_tool_wdlg )
			tst_replaceAllProps( repCate , repVal )
		end
		def show_tooldialog()
			if $bst_tool_wdlg
				$bst_tool_wdlg.bring_to_front
				##UI.messagebox "BST TOOL BOX is already running"
				return
			end
			#pfolder = File::dirname( bst_u8tosjis( Sketchup.find_support_files( "", "Plugins" )[0] ) )
			#wdlgpath = File.expand_path( File.join( pfolder , "building_structure_tool","bst_propery_man.html" ))
			bst_folder_path = bst_file_dirname( __FILE__ )
			#wdlgpath = File.join( bst_folder_path , "bst_property_man2.html" )
			
			bsthtml = bst_property_man_dummy() #readtextfile( wdlgpath )
			bsthtml = langconv_html(bsthtml)##added in Dec 31.2012.
			prfkeys = { 
				:dialog_title => langconv('BST tool Options'), 
				:scrollable => false, 
				:preferences_key => 'tst_bst_tool_option', 
				:height => 305, 
				:width => 435, 
				:left => 150, 
				:top => 150, 
				:resizable => true, 
				:mac_only_use_nswindow => true
			} 
			$bst_tool_wdlg = UI::WebDialog.new( prfkeys)
			###bst_tool_wdlg=UI::WebDialog.new('BST tool Options', false,'tst_bst_tool_option', 305, 435, 150, 150, true);bst_tool_wdlg.show;bst_tool_wdlg.set_position(100,50)
			ui = Sketchup.read_default("Structure Tool", "WDLG_UI",true)
=begin			
			fs = File.open( wdlgpath , "w+" )
			
			if fs
				p "show webdialog by FILE"
				bsthtml.gsub!("//BST_FOLDER//","")
				if ui == true
					bsthtml.gsub!("<!-- tab_ui_change_start -->","<!--")
					bsthtml.gsub!("<!-- tab_ui_change_end -->","-->")
				end
				fs.puts( bsthtml )
				fs.close
				$bst_tool_wdlg.set_file( wdlgpath )
			else
=end
				p "show webdialog by CODE"
				##このコードは実験的に変更しています
				bst_folder_path.gsub!(/\\/,"/")
				bsthtml.gsub!("//BST_FOLDER//",bst_folder_path)
				if ui == true
					bsthtml.gsub!("<!-- tab_ui_change_start -->","<!--")
					bsthtml.gsub!("<!-- tab_ui_change_end -->","-->")
				end
				##変更おわり
				$bst_tool_wdlg.set_html( bsthtml )	##変更箇所

			##end
			$bst_tool_wdlg.set_on_close{
				save_classdefault()
				$bst_tool_wdlg = nil
			}
			$bst_tool_wdlg.add_action_callback("save_default"){|d,prm|
				save_classdefault()
			}
			$bst_tool_wdlg.add_action_callback("getInformation"){|d,prm|
				get_information()
			}
			$bst_tool_wdlg.add_action_callback("apply_one"){|d,prm|
				#cateカテゴリ
				#val値
				ar = prm.split('|||||')
				cate = ar[0]
				val = ar[1]
				apply_one_prop( cate , val )
			}
			$bst_tool_wdlg.add_action_callback("startDrawing"){|d,prm|
				Sketchup.active_model.select_tool TST1_class_tool_for_wdlg_main.new($bst_tool_wdlg)
			}
			$bst_tool_wdlg.add_action_callback("applyAllProps"){|d,prm|
				applyAllProps()
			}
			$bst_tool_wdlg.add_action_callback("AutoCreateByFaces"){
			}
			$bst_tool_wdlg.add_action_callback("changeProp"){|d,prm|
				#cateカテゴリ
				#val値
				ar = prm.split('|||||')
				cate = ar[0]
				val = ar[1]
				#p cate + " " + val
				if val != ""
					if cate[/.*PROFILE.*/]
						@profile = val
					elsif cate[/.*TAG.*/]
						@tag = val
					elsif cate[/.*S_MAT.*/]
						@solid_mat = val
					elsif cate[/.*F_MAT.*/]
						@fmat = val
					elsif cate[/.*B_MAT.*/]
						@bmat = val
					elsif cate[/.*SEC_MAT.*/]
						@secmat = val
					elsif cate[/.*MIRR.*/]
					#p $bst_tool_wdlg.get_element_value("CHK_MIRR")
						if $bst_tool_wdlg.get_element_value("CHK_MIRR") == "YES"
							@beams_mirz = "Yes"
						end
					elsif cate[/.*ROTATE.*/]##
						@beams_rot = val
					elsif cate[/.*FIXZ.*/]##
						if $bst_tool_wdlg.get_element_value("CHK_FIXZ") == "YES"
							@beams_fixz = val
						else
							@beams_fixz = "0"
						end
					elsif cate[/.*HEIGHT.*/]##
						@beams_height = val
					elsif cate[/.*WIDTH.*/]##
						@wall_width = val
					elsif cate[/.*FLOOR.*/]##
						@beams_top = val
					elsif cate[/.*jst.*/]##
						@beams_just = "Left" if val == "1" or val == "4" or val == "7"
						@beams_just = "Center" if val == "2" or val == "5" or val == "8"
						@beams_just = "Right" if val == "3" or val == "6" or val == "9"
						@beams_vjust = "Top" if val == "7" or val == "8" or val == "9"
						@beams_vjust = "Middle" if val == "4" or val == "5" or val == "6"
						@beams_vjust = "Bottom" if val == "1" or val == "2" or val == "3"
					end
					@beams_spec = '"' + [ @tag,@profile,@beams_top,@solid_mat,@beams_rot,@fmat,@bmat,@secmat ].join('","') + '"'
				end
			}
			$bst_tool_wdlg.add_action_callback("changeBstClass"){|d,prm|
				Sketchup.active_model.select_tool nil
				init_webdialog( prm )
			}
			$bst_tool_wdlg.add_action_callback("tool_ex2face"){|d,p|
				Sketchup.active_model.select_tool TST1_class_extend_face.new( false )
			}
			$bst_tool_wdlg.add_action_callback("tool_extend"){|d,p|
				Sketchup.active_model.select_tool TST1_class_extend_str.new
			}
			$bst_tool_wdlg.add_action_callback("tool_grow"){|d,p|
				Sketchup.active_model.select_tool TST1_class_grow_face.new( false )
			}
			$bst_tool_wdlg.add_action_callback("tool_combine"){|d,p|
				Sketchup.active_model.select_tool TST1_class_chamfer.new
			}
			$bst_tool_wdlg.add_action_callback("tool_exchange"){|d,p|
				TST_common.tst_exchange_dialog
			} 
			$bst_tool_wdlg.add_action_callback("tool_ex2face"){|d,p|
				Sketchup.active_model.select_tool TST1_class_extend_face.new( false )
			}
			$bst_tool_wdlg.add_action_callback("tool_extend"){|d,p|
				Sketchup.active_model.select_tool TST1_class_extend_str.new
			}
			$bst_tool_wdlg.add_action_callback("tool_grow"){|d,p|
				Sketchup.active_model.select_tool TST1_class_grow_face.new( false )
			}
			$bst_tool_wdlg.add_action_callback("tool_combine"){|d,p|
				Sketchup.active_model.select_tool TST1_class_chamfer.new
			}
			$bst_tool_wdlg.add_action_callback("toggle_ui"){|d,p|
				ui = Sketchup.read_default("Structure Tool", "WDLG_UI",true)
				if ui == true
					Sketchup.write_default("Structure Tool", "WDLG_UI",false)
				else
					Sketchup.write_default("Structure Tool", "WDLG_UI",true)
				end
				$bst_tool_wdlg.close
				show_tooldialog
			}
			#bst_wdlg.add_action_callback(""){|d,prm|
			#}
			if RUBY_PLATFORM[/darwin/]
				$bst_tool_wdlg.show_modal { init_webdialog }
			else
				$bst_tool_wdlg.show { init_webdialog }
			end
		end

end#class
end#module
