#Chamfer_structures.
# Copyright TAK2
###[NOTICE]]####
#Strongly Recommend Sketchup version 8 higher for using this.
#The copyright of this plug-in is in TAK2HATA. 
#Please use this plug-in in self-responsibility. 
#I do not take any responsibility. 
#You can use freely. 
#################

##require 'sketchup.rb'
require 'building_structure_tool/tst1_mod_extend_face_to_plane.rb'
#require 'building_structure_tool/tst1_mod_click_two_bst_entity.rb'
module TAK2HATA::BuildingStrcutureTool
module TST1_mod_chamfer
	include TST1_mod_extend_face_to_plane
	def initialize( twobst = true )
		sels = Sketchup.active_model.selection
		@ces = []
		@exist_sels = false
		sels.clear
		@twobst = twobst
		@ip = Sketchup::InputPoint.new
	end
	def second_entity_clicked( ces , ps1 , ce2 , ps2 ,dummy )
		ce = ces[0]
		operation_name = langconv( "Combine with Structure" )
		if Sketchup.version.to_f < 7.0
			Sketchup.active_model.start_operation operation_name
		else
			Sketchup.active_model.start_operation operation_name,true
		end
		
		chamfer_form_MS( ce , ps1 , ce2 , ps2)
		Sketchup.active_model.commit_operation
	end
	def chamfer_form_MS( cform1 , ps1 , cform2 , ps2 )
		operation_name = langconv( "Convine Structures" )
		if Sketchup.version.to_f < 7.0
			Sketchup.active_model.start_operation operation_name
		else
			Sketchup.active_model.start_operation operation_name,true
		end
		
			if cform1.get_attribute( "BEAM_SPECS","CLASS" ) == "MWALL" and cform2.get_attribute( "BEAM_SPECS","CLASS" ) == "MWALL"
				attlist1 = cform1.entities.collect{|e| e.get_attribute("BEAM_SPECS","HUGO") }.delete_if{|d| d == nil }.sort
				attlist2 = cform2.entities.collect{|e| e.get_attribute("BEAM_SPECS","HUGO")}.delete_if{|d| d == nil }.sort
				if attlist1.size == attlist1.uniq.size and attlist2.size == attlist2.uniq.size and attlist1 == attlist2
					#１つの複合壁に同じパーツが存在しない場合のみパーツごとの接合を行う
					attlist1.each{|att|
						ce = cform1.entities.find{|e| e.get_attribute("BEAM_SPECS","HUGO") == att }
						ce.make_unique
						ce2 = cform2.entities.find{|e| e.get_attribute("BEAM_SPECS","HUGO") == att }
						ce2.make_unique
						#p att
						chamfer_form( ce , ps1 , ce2 , ps2 , cform1.transformation , cform2.transformation )
						chamfer_form( ce2 , ps2 , ce , ps1 , cform2.transformation , cform1.transformation )
					}
				elsif cform1.get_attribute( "BEAM_SPECS","HUGO" ) == cform2.get_attribute( "BEAM_SPECS","HUGO" )
					#符号が一致する場合
					if cform1.entities.count == cform2.entities.count
						#かつ要素数が一致する場合
						c1count = cform1.entities.count
						c1count.times{|i|
							ce = cform1.entities.find{|e| e.get_attribute("BEAM_SPECS","COUNT") == i.to_s }
							ce2 = cform2.entities.find{|e| e.get_attribute("BEAM_SPECS","COUNT") == i.to_s }
							if ce != nil and ce2 != nil
								ce.make_unique
								ce2.make_unique
								chamfer_form( ce , ps1 , ce2 , ps2 , cform1.transformation , cform2.transformation )
								chamfer_form( ce2 , ps2 , ce , ps1 , cform2.transformation , cform1.transformation )
							end
						}
					end
				end
			else
				chamfer_form( cform1, ps1 , cform2 , ps2)
				chamfer_form( cform2 , ps2 , cform1 , ps1)
			end
		Sketchup.active_model.commit_operation
	end
	def chamfer_form( cform1 , ps1 , cform2 , ps2 , ptf1 = Geom::Transformation.new( [0,0,0] ) , ptf2 = Geom::Transformation.new( [0,0,0] ) )
	#線形材の軸方向が平行な場合無駄なので終了する
	#線形材の幅を取り出す（Y方向が幅なのでheightで取り出すことになる
	tf1 = ptf1 * cform1.transformation
	tf2 = ptf2 * cform2.transformation
	xvec1 = Geom::Vector3d.new(1,0,0).transform( tf1 )
	xvec2 = Geom::Vector3d.new(1,0,0).transform( tf2 )
	zvec1 = Geom::Vector3d.new(0,0,1).transform( tf1 )
	return if xvec1.parallel?(xvec2)

	cform1 = cform1.definition if cform1.kind_of? Sketchup::ComponentInstance
	cform2 = cform2.definition if cform2.kind_of? Sketchup::ComponentInstance
	gr1bbmax , gr1bbmin = get_entitiesbounds( cform1.entities )
	gr2bbmax , gr2bbmin = get_entitiesbounds( cform2.entities )
	amax1 = gr1bbmax.y
	amin1 = gr1bbmin.y
	amax2 = gr2bbmax.y
	amin2 = gr2bbmin.y

	minvec = Geom::Vector3d.new(0,-1,0)
	maxvec = Geom::Vector3d.new(0,1,0)
	amin_plane1 = [ [0,amin1,0].transform( tf1 ) , minvec.transform( tf1 ) ]
	amax_plane1 = [ [0,amax1,0].transform( tf1 ) , maxvec.transform( tf1 ) ]
	amin_plane2 = [ [0,amin2,0].transform( tf2 ) , minvec.transform( tf2 ) ]
	amax_plane2 = [ [0,amax2,0].transform( tf2 ) , maxvec.transform( tf2 ) ]
	#クリックした点から近いほう遠いほうの判定で内外を決める
	dist_amin2 = ps1.distance_to_plane( amin_plane2 )
	dist_amax2 = ps1.distance_to_plane( amax_plane2 )
	if dist_amin2 > dist_amax2
		plane_in2 = amax_plane2
		plane_out2 = amin_plane2
	else
		plane_in2 = amin_plane2
		plane_out2 = amax_plane2
	end
	dist_amin1 = ps2.distance_to_plane( amin_plane1 )
	dist_amax1 = ps2.distance_to_plane( amax_plane1 )
	if dist_amin1 > dist_amax1
		plane_in1 = amax_plane1
		plane_out1 = amin_plane1
	else
		plane_in1 = amin_plane1
		plane_out1 = amax_plane1
	end
	#まず　構造フォームの開始面と終了面を取り出す
	fc_start = get_startface( cform1 )
	fc_end = get_endface( cform1 )
	inline = Geom.intersect_plane_plane( plane_in1 , plane_in2 )
	outline = Geom.intersect_plane_plane( plane_out1 , plane_out2 )
	#cform1の最上面と交点をさがす
	#tpt = cform1.local_bounds.max.transform( @tf1 )
	tpt = fc_end[0].bounds.max.transform( tf1 )
	bsptA = Geom.intersect_line_plane( inline , [ tpt , zvec1] )
	bsptB = Geom.intersect_line_plane( outline , [ tpt , zvec1] )
	#tpt = cform1.local_bounds.min.transform( @tf1 )
	tpt = fc_start[0].bounds.min.transform( tf1 )
	bsptC = Geom.intersect_line_plane( inline , [ tpt , zvec1] )
	plane2 = Geom.fit_plane_to_points( bsptA , bsptB , bsptC )


		xvec = Geom::Vector3d.new(1,0,0)
	#開始面、終了面、クリック点からの延長線を定義
		spt = fc_start[0].vertices[0].position.transform(tf1)
		ept = fc_end[0].vertices[0].position.transform(tf1)
		ppt = ps1
		sline = [ spt , xvec.transform(tf1) ]
		eline = [ ept , xvec.transform(tf1) ]
		pline = [ ppt , xvec.transform(tf1) ]

	#それぞれの交点を求める
		ipt_s = Geom.intersect_line_plane(sline, plane2)
		ipt_e = Geom.intersect_line_plane(eline, plane2)
		ipt_p = Geom.intersect_line_plane(pline, plane2)
		return if ipt_s == nil or ipt_e == nil or ipt_p == nil
	#それぞれの延長距離
		dist_s = ipt_s.distance( spt )
		dist_e = ipt_e.distance( ept )
		dist_p = ipt_p.distance( ppt )
		vec_s = spt.vector_to( ipt_s )
		vec_e = ept.vector_to( ipt_e )
		vec_p = ppt.vector_to( ipt_p )
	#fc1に移動すべき面を代入する
		modpos = "start"
	#既に延長先に接している場合
		if vec_s.length == 0
			fc1 = fc_start
		elsif vec_e.length == 0
			fc1 = fc_end
			modpos = "end"
		elsif vec_p.length == 0
			fc1 = fc_end
			modpos = "end"
		elsif vec_s.samedirection?( vec_p ) and vec_e.samedirection?( vec_p )
			if dist_s < dist_e
				fc1 = fc_start
			else
				fc1 = fc_end
				modpos = "end"
			end
		elsif vec_s.samedirection?( vec_p )
			fc1 = fc_end
			modpos = "end"
		else
			fc1 = fc_start
		end
		grp = fc1[0].parent

		
		#fc1.each{|fc|
		#	extend_do( cform1 , fc , tf1 , plane2 , xvec )
		#}
		extend_do_fcs( cform1 , fc1 , tf1 , plane2 , xvec , modpos )
		#modify_cline( grp , tf1 , modpos , xvec , plane2 )
		#Sketchup.active_model.commit_operation
	end
	def extend_form_do( ce , tf1 , ps1 , plane2 )#####################
	#まず　構造フォームの開始面と終了面を取り出す
		cform1 = ce
		cform1 = ce.definition if ce.kind_of? Sketchup::ComponentInstance
		fc_start = get_startface( cform1 )
		fc_end = get_endface( cform1 )
		xvec = Geom::Vector3d.new(1,0,0)
	#開始面、終了面、クリック点からの延長線を定義
		spt = fc_start[0].vertices[0].position.transform(tf1)
		ept = fc_end[0].vertices[0].position.transform(tf1)
		ppt = ps1
		sline = [ spt , xvec.transform(tf1) ]
		eline = [ ept , xvec.transform(tf1) ]
		pline = [ ppt , xvec.transform(tf1) ]
	#延長先の面のプレーンを定義
		#plane2 = fc2.plane
		#plane2 = [fc2.vertices[0].position.transform(tf2),fc2.normal.transform(tf2)] if tf2 != nil
	#それぞれの交点を求める
		ipt_s = Geom.intersect_line_plane(sline, plane2)
		ipt_e = Geom.intersect_line_plane(eline, plane2)
		ipt_p = Geom.intersect_line_plane(pline, plane2)
		return if ipt_s == nil or ipt_e == nil or ipt_p == nil
	#それぞれの延長距離
		dist_s = ipt_s.distance( spt )
		dist_e = ipt_e.distance( ept )
		dist_p = ipt_p.distance( ppt )
		vec_s = spt.vector_to( ipt_s )
		vec_e = ept.vector_to( ipt_e )
		vec_p = ppt.vector_to( ipt_p )
	#fc1に移動すべき面を代入する
		modpos = "start"
	#既に延長先に接している場合
		if vec_s.length == 0
			fc1 = fc_start
		elsif vec_e.length == 0
			fc1 = fc_end
			modpos = "end"
		elsif vec_s.samedirection?( vec_p ) and vec_e.samedirection?( vec_p )
			if dist_s < dist_e
				fc1 = fc_start
			else
				fc1 = fc_end
				modpos = "end"
			end
		elsif vec_s.samedirection?( vec_p )
			fc1 = fc_end
			modpos = "end"
		else
			fc1 = fc_start
		end
		
		grp = fc1[0].parent


		#fc1.each{|fc|
		#	extend_do( cform1 , fc , tf1 , plane2 , xvec )
		#}
		
		extend_do_fcs( cform1 , fc1 , tf1 , plane2 , xvec , modpos )
		#Sketchup.active_model.commit_operation
	end####################

end # of module
end#module