#require 'sketchup.rb'
module TAK2HATA::BuildingStrcutureTool
module TST1_mod_click_two_entity
def initialize( twobst = true )
	sels = Sketchup.active_model.selection
	@ces = []
	@exist_sels = false
	sels.each{|se|
		if se.kind_of? Sketchup::ComponentInstance or se.kind_of? Sketchup::Group
			if se.get_attribute( "BEAM_SPECS","CURVE" ) == false
				@ces.push se.make_unique
			end
		end
	}
	@exist_sels = true if @ces.size > 0
	@twobst = twobst
	@ip = Sketchup::InputPoint.new
end
def reset
	@ip.clear
	@pt1 = Geom::Point3d.new
	@pt2 = Geom::Point3d.new
    @state = 0
    model = Sketchup.active_model
    @selection = model.selection
    @selection.clear
	Sketchup::set_status_text langconv( "Select 1st Structure" )
end

def activate
	reset
	increment_state( Sketchup.active_model.active_view ) if @ces.size > 0
end

def increment_state(view)
    @state += 1
    case @state
    when 1
		if @twobst == true
        	Sketchup::set_status_text langconv( "Select ２nd structure" )
		else
        	Sketchup::set_status_text langconv( "Select Face extend for." )
		end
    when 2
		if @twobst == true
			self.second_entity_clicked( @ces , @ps1 , @ce2 , @ps2 , @exist_sels )
		else
			self.second_entity_clicked2( @ces , @ps1 , @tf1 , @fc2 , @tf2 , @exist_sels )
			#self.extend_form_to_face( @ce , @ps1 , @tf1 , @fc2 , @tf2 )
		end
		@exist_sels = false
		view.invalidate
		self.reset
    end
end

def onMouseMove(flags, x, y, view)

end

def onLButtonDown(flags, x, y, view)
	@ip.pick(view,x,y)
	ph = view.pick_helper
	ph.do_pick x,y
	pe = ph.best_picked
	face = @ip.face
	edge = @ip.edge

	model = Sketchup.active_model
	#cmodel = model.active_entities.parent
  case @state
  when 0
	if pe.kind_of? Sketchup::ComponentInstance or pe.kind_of? Sketchup::Group
		if pe.get_attribute( "BEAM_SPECS","CURVE" ) == false
			@ce = pe.make_unique
			@ces =[ @ce ]
			#if @ce.parent.entityID == cmodel.entityID
				
				@tf1 = @ip.transformation
				@ps1 = @ip.position
				@selection.add @ce
				self.increment_state(view)
			#else
			#	@ce = nil
			#end
		end
	end
  when 1
	if @twobst == true
		#二つともBST要素を選択の場合
		if pe.kind_of? Sketchup::ComponentInstance or pe.kind_of? Sketchup::Group
			if pe.get_attribute( "BEAM_SPECS","CURVE" ) == false
				@ce2 = pe.make_unique

				@tf2 = @ip.transformation
				@ps2 = @ip.position
				@selection.add @ce2
				self.increment_state(view)
			end
		end
	else
		#二つ目は面要素を選択する場合
		if face != nil
			@fc2 = nil
			@tf2 = nil
			if @ip.face
				@fc2 = @ip.face
				@tf2 = @ip.transformation
				if @fc2.parent.kind_of? Sketchup::ComponentDefinition
					if @fc2.parent.instances[0].kind_of? Sketchup::Group
						@ces.each{|ce|
						if @fc2.parent.instances[0].entityID == ce.entityID
							@fc2 = nil
							return
						end
						}
					end
				end
			end
			self.increment_state(view) if @fc2
		end
	end
  end
end
end # of class
end#module
