require 'building_structure_tool/tst1_mod_profile_gen.rb'
require 'building_structure_tool/tst1_mod_chamfer.rb'
##modified in 2013 02 19.
module TAK2HATA::BuildingStrcutureTool
module TST1_mod_create_geometry
	include TST1_mod_profile_gen
	include TST1_mod_chamfer
	def create_geometry( bclass , pts , beams_spec , beams_just , beams_vjust , beams_axis , beams_top , beams_rot , beams_mirz , wall_width , beams_height , pgeom = nil , sidevec = nil)

		@bclass = bclass
		cgeom = drawStructure( pts , beams_spec , beams_just , beams_vjust , beams_axis , beams_top , beams_rot , beams_mirz , wall_width , beams_height , sidevec )
		if pgeom != nil and ( bclass == "RC_WALL" or bclass == "MWALL" )
			
			chamfer_form_MS( cgeom , cgeom.bounds.center , pgeom , pgeom.bounds.center )
		end
		pgeom = nil
		#Sketchup.active_model.commit_operation
		
		if bclass == "RC_WALL" or bclass == "MWALL"
			return cgeom
		else
			return nil
		end
	end
	def create_geometry2( pts , beams_props , pgeom = nil , sidevec = nil)

		@bclass = beams_props[0]
		cgeom = drawStructure2( pts , beams_props , sidevec )
		if pgeom != nil and ( @bclass == "RC_WALL" or @bclass == "MWALL" )
			chamfer_form_MS( cgeom , cgeom.bounds.center , pgeom , pgeom.bounds.center )
		end
		pgeom = nil
		#Sketchup.active_model.commit_operation
		if @bclass == "RC_WALL" or @bclass == "MWALL"
			return cgeom
		else
			return nil
		end
	end
	def drawStructure( pts , beams_spec , beams_just , beams_vjust , beams_axis , beams_top , beams_rot , beams_mirz , wall_width , beams_height , sidevec = nil , tgr = nil )
		bspecs = beams_spec.split("\t")
		beams_props = []
		beams_props[0] = @bclass
		beams_props[1] = bspecs[0]
		beams_props[2] = bspecs[1]
		beams_props[3] = bspecs[2]
		beams_props[4] = bspecs[3]
		beams_props[5] = getNumeric( bspecs[4] )
		beams_props[6] = bspecs[5]
		beams_props[7] = bspecs[6]
		beams_props[8] = bspecs[7]
		beams_props[9] = beams_just
		beams_props[10] = beams_vjust
		beams_props[11] = beams_axis
		beams_props[12] = beams_top
		beams_props[13] = getNumeric( beams_rot )
		beams_props[14] = beams_mirz
		beams_props[15] = wall_width
		beams_props[16] = beams_height
	
		drawStructure2( pts , beams_props , sidevec , tgr )
	end
	def drawStructure2( pts , beams_props , sidevec = nil , tgr = nil , topfc = nil , btmfc = nil , stfc = nil , enfc = nil , changeheight = false )
		Sketchup.active_model.layers.add "Structure-#{@bclass}"

		bclass = beams_props[0]
		hugo = beams_props[1]
		bprofile = beams_props[2]
		fl = beams_props[3]
		mat = beams_props[4]
		rot = beams_props[5].degrees
		fm_name = beams_props[6]
		bm_name = beams_props[7]
		sm_name = beams_props[8]
		beams_just = beams_props[9]
		beams_vjust = beams_props[10]
		beams_axis = beams_props[11]
		beams_top = beams_props[12]
		beams_rot = beams_props[13].degrees
		beams_mirz = beams_props[14]
		wall_width = beams_props[15]
		beams_height = beams_props[16]

		if bclass == "MWALL"
			grp = drawMwall( pts , bprofile , beams_mirz )
			return grp
		end

		grp=Sketchup.active_model.active_entities.add_group
		ents=grp.entities

		fl = fl + beams_top
		rot = rot + beams_rot
		shapePts = []
		shapetype = ""

		gw = 0.0
		gh = 0.0
#Improving in 2013.11.02
reg = Regexp.new("ruby")
styles = Hash.new
#styles["expression for shapes"] = [ Shape Type , Parameter name with delimiter ]
styles["BH-0x0x0x0x0"] = [ "H" , ["gh","gw","t1","t2","r1"] ]
styles["BH-0x0x0x0"] = [ "H" , ["gh","gw","t1","t2"] ]
styles["H-0x0x0x0x0"] = [ "H" , ["gh","gw","t1","t2","r1"] ]
styles["H-0x0x0x0"] = [ "H" , ["gh","gw","t1","t2"] ]

styles["FB-0x0"] = [ "FB" , ["gh","gw"] ]

styles["CT-0x0x0x0x0"] = [ "T" , ["gh","gw","t1","t2","r1"] ]
styles["T-0x0x0x0x0"] = [ "T" , ["gh","gw","t1","t2","r1"] ]
styles["CT-0x0x0x0"] = [ "T" , ["gh","gw","t1","t2"] ]
styles["T-0x0x0x0"] = [ "T" , ["gh","gw","t1","t2"] ]

styles["SHS-0x0x0x0"] = [ "SHS" , ["gh","gw","t1","t2"] ]
styles["SHS-0x0x0"] = [ "SHS" , ["gh","gw","t1"] ]

styles["CHS-0x0"] = [ "CHS" , "r,t" ]

styles["L-0x0x0x0x0"] = [ "L" , "h,w,t1,r1,r2" ]
styles["L-0x0x0"] = [ "L" , "h,w,t1" ]

styles["C-0x0x0x0"] = [ "C" , "h,w,t1,t2" ]
styles["[-0x0x0x0x0x0"] = [ "CC" , "h,w,t1,t2,r1,r2" ]
styles["[-0x0x0x0"] = [ "CC" , "h,w,t1,t2" ]
styles["RC-0x0"] = [ "RC" , "h,w" ]
styles["0x0"] = [ "RC" , "h,w" ]
styles["RCW-0"] = [ "RCW" , "w" ]
styles["W-0"] = [ "RCW" , "w" ]
styles["RCF-0x0x0"] = [ "RCF" , "w,h,d" ]
#replace for regular expressions
#0-->*(\d+\.*\d*)
#x-->[xX]
## styles.keys.each{|stylekey|
##stylepattern = stylekey
##stylepattern.gsub!(/0/,'*(\d+\.*\d*)')
##stylepattern.gsub!(/x/,'[xX]')
##if bprofile[/^#{stylepattern}/]
##break
##end
##}
		if bprofile[/^\[SHAPE\](.*)/]
			shapename = $1.to_s
			shapetype = "SHAPE"
		elsif bprofile[/^B*H-*(\d+\.*\d*)[xX](\d+\.*\d*)[xX](\d+\.*\d*)[xX](\d+\.*\d*)/]
		#H-STEEL
			gh  = getLengthByUnits( $1 )
			gw  = getLengthByUnits( $2 )
			gt1 = getLengthByUnits( $3 )
			gt2 = getLengthByUnits( $4 )
			r1 = 0.0
			if bprofile[/^B*H-*(\d+\.*\d*)[xX](\d+\.*\d*)[xX](\d+\.*\d*)[xX](\d+\.*\d*)[xX](\d+\.*\d*)/]
				r1 = getLengthByUnits( $5 )
			end
			shapetype = "H"
		elsif bprofile[/^FB-*(\d+\.*\d*)[xX](\d+\.*\d*)/]
		#Cut Tee -STEEL
			gh = getLengthByUnits( $1 )
			gw = getLengthByUnits( $2 )
			shapetype = "FB"
		elsif bprofile[/^C*T-*(\d+\.*\d*)[xX](\d+\.*\d*)[xX](\d+\.*\d*)[xX](\d+\.*\d*)/]
		#CT-STEEL
			gh  = getLengthByUnits( $1 )
			gw  = getLengthByUnits( $2 )
			gt1 = getLengthByUnits( $3 )
			gt2 = getLengthByUnits( $4 )
			r1 = 0.0
			if bprofile[/^C*T-*(\d+\.*\d*)[xX](\d+\.*\d*)[xX](\d+\.*\d*)[xX](\d+\.*\d*)[xX](\d+\.*\d*)/]
				r1 = getLengthByUnits( $5 )
			end
			shapetype = "T"
		elsif bprofile[/^SHS-*(\d+\.*\d*)[xX](\d+\.*\d*)[xX](\d+\.*\d*)/]
		#Rectang shape-STEEL
			gh  = getLengthByUnits( $1 )
			gw  = getLengthByUnits( $2 )
			gt1 = getLengthByUnits( $3 )
			r1 = 0.0
			if bprofile[/^SHS-*(\d+\.*\d*)[xX](\d+\.*\d*)[xX](\d+\.*\d*)[xX](\d+\.*\d*)/]
				r1 = getLengthByUnits( $4 )
			end
			shapetype = "SHS"

		elsif bprofile[/^CHS-*(\d+\.*\d*)[xX](\d+\.*\d*)/]
		#Circleshape-STEEL
			gh  = getLengthByUnits( $1 )
			gw = gh
			r = gh / 2.0
			gt1 = getLengthByUnits( $2 )
			shapetype = "CHS"
		elsif bprofile[/^L-*(\d+\.*\d*)[xX](\d+\.*\d*)[xX](\d+\.*\d*)/]
		#L-STEEL
			gh  = getLengthByUnits( $1 )
			gw  = getLengthByUnits( $2 )
			gt1 = getLengthByUnits( $3 )
			gt2 = gt1
			r1 = 0.0
			r2 = 0.0
			if bprofile[/^L-*(\d+\.*\d*)[xX](\d+\.*\d*)[xX](\d+\.*\d*)[xX](\d+\.*\d*)[xX](\d+\.*\d*)/]
				r1 = getLengthByUnits( $4 )
				r2 = getLengthByUnits( $5 )
			end
			shapetype = "L"
		#add_Lshape_face( gfrp , gw , gh , gt1 ,r1 , r2)
		elsif bprofile[/^C-*(\d+\.*\d*)[xX](\d+\.*\d*)[xX](\d+\.*\d*)[xX](\d+\.*\d*)/]
		#C-STEEL
			gh  = getLengthByUnits( $1 )
			gw  = getLengthByUnits( $2 )
			gt1 = getLengthByUnits( $3 )
			gt2 = getLengthByUnits( $4 )

			shapetype = "C"
		elsif bprofile[/^\[-*(\d+\.*\d*)[xX](\d+\.*\d*)[xX](\d+\.*\d*)[xX](\d+\.*\d*)/]
		#[-STEEL
			gh  = getLengthByUnits( $1 )
			gw  = getLengthByUnits( $2 )
			gt1 = getLengthByUnits( $3 )
			gt2 = getLengthByUnits( $4 )
			r1 = 0.0
			r2 = 0.0
			if bprofile[/^\[-*(\d+\.*\d*)[xX](\d+\.*\d*)[xX](\d+\.*\d*)[xX](\d+\.*\d*)[xX](\d+\.*\d*)[xX](\d+\.*\d*)/]
				r1 = getLengthByUnits( $5 )
				r2 = getLengthByUnits( $6 )
			end
			shapetype = "CC"
		elsif bprofile[/^RC-*(\d+\.*\d*)[xX](\d+\.*\d*)/] or bprofile[/^(\d+\.*\d*)[xX](\d+\.*\d*)/]
			gh  = getLengthByUnits( $2 )
			gw  = getLengthByUnits( $1 )
			shapePts.push [ 0, -gw/2 , gh/2]
			shapePts.push [ 0, gw/2 , gh/2]
			shapePts.push [ 0, gw/2 , -gh/2]
			shapePts.push [ 0, -gw/2 , -gh/2]
			shapetype = "RECT"
		elsif bprofile[/^RCW-*(\d+\.*\d*)/] or bprofile[/^W-*(\d+\.*\d*)/]
			gh = beams_height
			gw = 0.0
			gw = getLengthByUnits( $1 ) if $1
			gw = wall_width if gw == 0.0
			shapePts.push [ 0, -gw/2 , gh/2]
			shapePts.push [ 0, gw/2 , gh/2]
			shapePts.push [ 0, gw/2 , -gh/2]
			shapePts.push [ 0, -gw/2 , -gh/2]
			shapetype = "RECT"
		elsif bprofile[/^RCF-*(\d+\.*\d*)[xX](\d+\.*\d*)[xX](\d+\.*\d*)/]
			#UI.messagebox "test"
			gh  = getLengthByUnits( $2 )
			gw  = getLengthByUnits( $1 )
			pts[1] = [ pts[0].x , pts[0].y , pts[0].z - getLengthByUnits( $3 ) ]
			shapePts.push [ 0, -gw/2 , gh/2]
			shapePts.push [ 0, gw/2 , gh/2]
			shapePts.push [ 0, gw/2 , -gh/2]
			shapePts.push [ 0, -gw/2 , -gh/2]
		else
			return
		end

		ozvec = Geom::Vector3d.new( 0,0,1 )
		oyvec = Geom::Vector3d.new( 0,1,0 )
		
		vec1to2 = pts[0].vector_to( pts[1] )
		dist = pts[0].distance(pts[1])
		xvec = vec1to2.normalize!
		#xvecはパスの方向のベクトル
		
		is_column = false
		if sidevec != nil and not sidevec.parallel?( xvec )
			#sidevecが指定されていて、sidevecとxvec（パス）が平行ではない場合
			zvec = sideve.cross( xvec ).reverse
			yvec = szvec.cross( xvec ).reverse
		else
			#sidevecが指定されていないか、sidevecとxvec（パス）が平行な場合
			if xvec.parallel?( ozvec ) or changeheight
				#xvec（パス）がZ軸と平行な場合（柱系）
				yvec =  Geom::Vector3d.new( 1,0,0 )
				zvec = yvec.cross( xvec ).normalize.reverse
				is_column = true
				dist = beams_height if beams_height > 0
				#p beams_height
			else
				#p "not para zvec"
				yvec = xvec.cross( ozvec ).normalize
				#zvec = ozvec
				zvec = yvec.cross( xvec ).normalize
				#yvec.cross( xvec ).normalize
			end
		end

		trot = Geom::Transformation.rotation Geom::Point3d.new(0,0,0) , Geom::Vector3d.new( 1,0,0 ) , 0
		if rot == 90.degrees
			gw , gh = gh ,gw
		end	

		if beams_just == "Left"
			tvec = Geom::Vector3d.new 0,-gw/2,0
		elsif beams_just == "Right"
			tvec = Geom::Vector3d.new 0,gw/2,0
		elsif beams_just == "Center"
			tvec = Geom::Vector3d.new 0,0,0
		end
		if beams_vjust == "Top"
			tvvec = Geom::Vector3d.new 0,0,-gh/2
		elsif beams_vjust == "Bottom"
			tvvec = Geom::Vector3d.new 0,0,gh/2
		elsif beams_vjust == "Middle"
			tvvec = Geom::Vector3d.new 0,0,0
		end
		if tgr == nil
			#if beams_axis == "Yes"
				cline=ents.add_cline([0,0,0],[ dist , 0, 0 ] )
				cline.stipple="-.-"
				tgr = Geom::Transformation.translation tvec
				ents.transform_entities(tgr,cline)
			#end
			
			tgr = Geom::Transformation.axes pts[0], xvec, yvec, zvec
			if fl != 0.0
				tvvec2 = Geom::Vector3d.new 0,0,fl
				tgr = Geom::Transformation.translation( tvvec2 ) * tgr
			end
		end
		grp.transform! tgr
		
		
		##shorino junban wo saikentousuru
		if rot == 90.degrees
			gw , gh = gh ,gw
		end	
			if shapetype == "SHAPE"
				fc = add_shapecomp_face( grp , shapename , gw , gh )
			elsif shapetype == "H"
				fc = add_Hshape_face( grp , gw , gh , gt1 , gt2 , r1  )
			elsif shapetype == "T"
				fc = add_Tshape_face( grp , gw , gh , gt1 , gt2 , r1  )
			elsif shapetype == "FB"
				fc = add_FBshape_face( grp , gw , gh )
			elsif shapetype == "SHS"
				fc = add_SHshape_face( grp , gw , gh , gt1 , r1 )
			elsif shapetype == "CHS"
				fc = add_CHshape_face( grp , gw , gh , gt1 , r )
			elsif shapetype == "L"
				fc = add_Lshape_face( grp , gw , gh , gt1 , gt2 ,r1 , r2 )
			elsif shapetype == "C"
				fc = add_Cshape_face( grp , gw , gh , gt1 ,gt2 )
			elsif shapetype == "CC"
				fc = add_CCshape_face( grp , gw , gh , gt1 , gt2, r1 , r2 )
			else
				fc = ents.add_face( shapePts )
			end
		if rot == 90.degrees
			gw , gh = gh ,gw
		end	
		
		if fm_name != ""
			fmat = add_new_material( fm_name )
			fc.material = fmat
		end
		if bm_name != ""
			bmat = add_new_material( bm_name )
			fc.back_material = bmat
		end
		if sm_name != ""
			smmat = add_new_material( sm_name )
			grp.material = smmat
		end
		if rot != 0
			trot = Geom::Transformation.rotation Geom::Point3d.new(0,0,0) , Geom::Vector3d.new( 1,0,0 ) , rot
			ents.transform_entities(trot,fc)
		end
		#if is_column == false #柱系の場合は位置(just-vjust）を無視していたが、今回はあえて無視しない
			tvec = tvec + tvvec# + Geom::Vector3d.new( 0, 0 , beams_top )
			t = Geom::Transformation.translation tvec
			ents.transform_entities(t,fc)
		#end
		if beams_mirz == "Yes"
			t = Geom::Transformation.scaling [0,0,0], 1 , -1 , 1
			ents.transform_entities(t,fc)
		end
		fc.reverse!
		fc.set_attribute( "BEAMS_FACES", "LOCATION" , "FC_END")
		ptpts = pts.collect{|ptpt| ptpt.transform( tgr.inverse ) }
		#p "#{dist}"
		if pts.size == 2
			fc.pushpull dist,true
			fc.reverse!	
			fc.set_attribute( "BEAMS_FACES", "LOCATION" , "FC_START")
			startfcvec = fc.normal
		else
			#if is_column == false
			#コラムの場合にパスが曲線のものを無視していたが、今回は無視せずに作る
				rail = ents.add_curve( ptpts )
				fc.reverse!
				fc.followme rail
				fc.set_attribute( "BEAMS_FACES", "LOCATION" , "FC_START") if fc.valid?
				startfcvec = fc.normal if fc.valid?
			#else
			#	return
			#end
		end
		#startfcvec = ptpts[1].vector_to( ptpts[0] )
		endfcvec = startfcvec.reverse if startfcvec != nil

		grp.entities.find_all{|e| e.kind_of? Sketchup::Face }.each{|fc|

			softedges = fc.edges.find_all{|fced| fced.soft? == true }
			if endfcvec != nil and fc.normal.samedirection?( endfcvec ) and softedges == []
				#if @bclass == "RC_COLUMN" or @bclass == "STEEL_COLUMN"
				#	fc.set_attribute( "BEAMS_FACES", "LOCATION" , "FC_TOP")
				#else
					fc.set_attribute( "BEAMS_FACES", "LOCATION" , "FC_END")
				#end
			elsif startfcvec != nil and fc.normal.samedirection?( startfcvec ) and softedges == []
				#if @bclass == "RC_COLUMN" or @bclass == "STEEL_COLUMN"
				#	fc.set_attribute( "BEAMS_FACES", "LOCATION" , "FC_BOTTOM")
				#else
					fc.set_attribute( "BEAMS_FACES", "LOCATION" , "FC_START")
				#end
			elsif @bclass == "RC_WALL" #shapetype == "RECT" #bprofile[/RC.*/]
				if fc.normal.samedirection? Geom::Vector3d.new( 0,0,1 )
					fc.set_attribute( "BEAMS_FACES", "LOCATION" , "FC_TOP")
				elsif fc.normal.samedirection? Geom::Vector3d.new( 0,0,-1 )
					fc.set_attribute( "BEAMS_FACES", "LOCATION" , "FC_BOTTOM")
				elsif fc.normal.samedirection? Geom::Vector3d.new( 0,-1,0 )
					fc.set_attribute( "BEAMS_FACES", "LOCATION" , "FC_LEFT")
				elsif fc.normal.samedirection? Geom::Vector3d.new( 0,1,0 )
					fc.set_attribute( "BEAMS_FACES", "LOCATION" , "FC_RIGHT")
				end
			else
				fc.set_attribute( "BEAMS_FACES", "LOCATION" , "FC_SIDE")
			end
		}

		grp.entities.find_all{|e| e.kind_of? Sketchup::Edge and e.smooth? == false }.each{|ed|
			ed.set_attribute "BEAMS_FACES", "LOCATION" , "ED_OUTLINE"
		}
		##extend with faces
		newtr = Geom::Transformation.new
			if changeheight == true and ( @bclass == "RC_COLUMN" or @bclass == "STEEL_COLUMN" )
				p "not fit to face"
			else
				if enfc != nil
					plane2 = enfc[0].plane
					fcs = get_endface( grp )
					if fcs != nil
					fcs.each{|fc|
						extend_do( grp , fc , newtr , plane2 )
					}
					end
				end
				if stfc != nil
					plane2 = stfc[0].plane
					fcs = get_startface( grp )
					if fcs != nil
					fcs.each{|fc|
						extend_do( grp , fc , newtr , plane2 )
					}
					end
				end
			end
			if changeheight == false
				if @bclass == "RC_WALL"  or @bclass == "RC_COLUMN" or @bclass == "STEEL_COLUMN"
					if btmfc != nil
						plane2 = btmfc[0].plane
						fcs = get_bottomface( grp )
						if fcs != nil
						fcs.each{|fc|
							extend_do( grp , fc , newtr , plane2 )
						}
						end
					end
				end
				if @bclass == "RC_WALL" or @bclass == "RC_COLUMN" or @bclass == "STEEL_COLUMN"
					if topfc != nil
						plane2 = topfc[0].plane
						fcs = get_topface( grp )
						if fcs != nil
						fcs.each{|fc|
							extend_do( grp , fc , newtr , plane2 )
						}
						end
					end
				end
			end
		##
		grp.name = "#{hugo}|#{bprofile}"
		grp.set_attribute "BEAM_SPECS","CLASS",@bclass
		grp.set_attribute "BEAM_SPECS","HUGO",hugo
		grp.set_attribute "BEAM_SPECS","PROFILE",bprofile
		grp.set_attribute "BEAM_SPECS","MATERIAL",mat
		#grp.set_attribute "BEAM_SPECS","FL",fl
		grp.set_attribute "BEAM_SPECS","ROTATE",rot
		grp.set_attribute "BEAM_SPECS","MIRRORZ",beams_mirz
		grp.set_attribute "BEAM_SPECS","PATH", pts#.map{|pt| pt.transform( grp.transformation.inverse ) }
		grp.set_attribute "BEAM_SPECS","HJUST", beams_just
		grp.set_attribute "BEAM_SPECS","VJUST", beams_vjust
		grp.set_attribute "BEAM_SPECS","TOP", beams_top
		grp.set_attribute "BEAM_SPECS","WIDTH", wall_width
		grp.set_attribute "BEAM_SPECS","HEIGHT", beams_height
		grp.set_attribute "BEAM_SPECS","SVEC", sidevec

		
		if ptpts.size > 2
			grp.set_attribute "BEAM_SPECS","CURVE",true
		else
			grp.set_attribute "BEAM_SPECS","CURVE",false
		end
		ipt = [ pts[0].distance( pts[1] )/2 , 0,0]
		#draw_hugo_text( grp , ipt , hugo , bprofile)
		
		grp.entities.find_all{|de| de.kind_of? Sketchup::Drawingelement }.each{|e| e.layer = "Structure-#{@bclass}" }
		 #topfc = nil , btmfc = nil , stfc = nil , enfc
		#p "add label"
		#label_hugo_text(grp , hugo , ipt )
		return grp
	end
	def drawMwall( pts , beams_prof , beams_mirz )
		model = Sketchup.active_model
		#pfolder = File::dirname( bst_u8tosjis( Sketchup.find_support_files( "", "Plugins" )[0] ) )
		
		#path = File.join( File.dirname( File.expand_path(__FILE__) ), 'mwalls' , bst_u8tosjis( beams_prof ) )
		path = bst_file_join( bst_file_dirname( __FILE__ ), 'mwalls' , bst_u8tosjis( beams_prof ) )
		#File.expand_path( File.join( pfolder ,'building_structure_tool', 'mwalls',bst_u8tosjis( beams_prof ) ) )
		
		return if FileTest.exist?(path) != true
		definitions = model.definitions
		cdef = definitions.load( path )
		cdbb = cdef.bounds
		cup = 0
		cdef.entities.find_all{|e| e.get_attribute( "BEAM_SPECS","CLASS" ) != nil }.each{|cdent|
			cdent.set_attribute("BEAM_SPECS","COUNT",cup.to_s) if cdent.get_attribute("BEAM_SPECS","COUNT") == nil
			cup += 1
		}
		gw = 0.0
		gh = 0.0
		gh = cdbb.height
		gw = cdbb.depth
		
		tf = Geom::Transformation.new( Geom::Point3d.new( 0,0,0 ) )
		grp = Sketchup.active_model.active_entities.add_group
		ents = grp.entities
		cins = ents.add_instance( cdef , tf )
		cins.explode

		ozvec = Geom::Vector3d.new( 0,0,1 )
		sec = Sketchup.active_model.selection.find_all{|se| se.kind_of? Sketchup::SectionPlane }
		if sec != []
			ozvec = Geom::Vector3d.new( -sec[0].get_plane[0] , -sec[0].get_plane[1] , -sec[0].get_plane[2] )
		end
		if ozvec.parallel?( Geom::Vector3d.new( 0,0,1 ) )
			oyvec = Geom::Vector3d.new( 0,1,0 )
		else
			oyvec = ozvec.cross( Geom::Vector3d.new( 0,0,1 ) ).normalize
		end
		vec1to2 = pts[0].vector_to( pts[1] )
		dist = pts[0].distance(pts[1])
		xvec = vec1to2.normalize!
		col = false
		
		if xvec.parallel?( ozvec )
			yvec = oyvec
			zvec = yvec.cross( xvec ).normalize
			col = true
		else
			yvec = xvec.cross( ozvec ).normalize
			zvec = yvec.cross( xvec ).normalize
		end
		
		tvec = Geom::Vector3d.new 0,0,0
		trot = Geom::Transformation.rotation Geom::Point3d.new(0,0,0) , Geom::Vector3d.new( 1,0,0 ) , 0

		tgr = Geom::Transformation.axes pts[0], xvec, yvec, zvec

		grp.transform! tgr

		##My Mistake. Mwall is create mirrored about imaging.
		if beams_mirz == "Yes"
		else
			t = Geom::Transformation.scaling [0,0,0], 1 , -1 , 1
			ents.transform_entities(t, ents.collect{|e| e } )
		end

		ptpts = pts.collect{|ptpt| ptpt.transform( tgr.inverse ) }
		if pts.size == 2

			ents.each{|ent|
				if ent.kind_of? Sketchup::ComponentInstance or ent.kind_of? Sketchup::Group
					ent.make_unique
					ps1 = Geom::Point3d.new(0,0,0)
					tf1 = ent.transformation
					plane2 = [ Geom::Point3d.new( dist,0,0 ) , Geom::Vector3d.new( -1,0,0) ]
					extend_form_do( ent , tf1 , ps1 , plane2 )
				end
			}
		else
			#if col == false
			#	rail = ents.add_curve( ptpts )
			#	fc.reverse!
			#	fc.followme rail
			#else
			#	return
			#end
		end
		if ents.find_all{|e| e.get_attribute( "BEAM_SPECS","CLASS","" ) != "" }.size == 1
			exents = grp.explode
			retent = exents.find_all{|e| e.get_attribute( "BEAM_SPECS","CLASS","" ) != "" }[0]
			return retent
		else
			##grp.name = "MWALL-#{ File.basename( beams_prof , "*.skp" )}"
			grp.name = "MWALL-#{ bst_file_basename( beams_prof , "*.skp" )}"
			grp.set_attribute "BEAM_SPECS","CLASS",@bclass
			grp.set_attribute "BEAM_SPECS","HUGO", beams_prof
			grp.set_attribute "BEAM_SPECS","PROFILE", beams_prof
			grp.set_attribute "BEAM_SPECS","PATH", pts
			grp.set_attribute "BEAM_SPECS","MIRRORZ",beams_mirz
			if ptpts.size > 2
				grp.set_attribute "BEAM_SPECS","CURVE",true
			else
				grp.set_attribute "BEAM_SPECS","CURVE",false
			end
			ipt = [ pts[0].distance( pts[1] )/2 , 0,0]

			return grp
		end
	end
	def auto_create_from_lines( bclass , beams_spec , beams_just , beams_vjust , beams_axis , beams_top , beams_rot , beams_mirz , wall_width , beams_height ,sellines = [] )
		bspecs = beams_spec.split("\t")
		beams_props = []
		beams_props[0] = bclass
		beams_props[1] = bspecs[0]
		beams_props[2] = bspecs[1]
		beams_props[3] = bspecs[2]
		beams_props[4] = bspecs[3]
		beams_props[5] = getNumeric( bspecs[4] )
		beams_props[6] = bspecs[5]
		beams_props[7] = bspecs[6]
		beams_props[8] = bspecs[7]
		beams_props[9] = beams_just
		beams_props[10] = beams_vjust
		beams_props[11] = beams_axis
		beams_props[12] = beams_top
		beams_props[13] = getNumeric( beams_rot )
		beams_props[14] = beams_mirz
		beams_props[15] = wall_width
		beams_props[16] = beams_height
	
		auto_create_from_lines2( beams_props , sellines )
	end
	def auto_create_from_lines2( beams_props , sellines , nvec = nil )
		#@bclass = bclass
		allpts = []
		bclass = beams_props[0]
		hugo = beams_props[1]
		bprofile = beams_props[2]
		fl = beams_props[3]
		mat = beams_props[4]
		rot = beams_props[5].degrees
		fm_name = beams_props[6]
		bm_name = beams_props[7]
		sm_name = beams_props[8]
		beams_just = beams_props[9]
		beams_vjust = beams_props[10]
		beams_axis = beams_props[11]
		beams_top = beams_props[12]
		beams_rot = beams_props[13].degrees
		beams_mirz = beams_props[14]
		wall_width = beams_props[15]
		beams_height = beams_props[16]
		
		operation_name = langconv("Draw Multi Building Structures")
		if Sketchup.version.to_f < 7.0
			Sketchup.active_model.start_operation operation_name
		else
			Sketchup.active_model.start_operation operation_name,true
		end

		pts = []
		curveids = []
		ppts = []
		pgeom = nil
		##
		sellines.each{|e|
			pts = []
			#MWALLの場合はセグメントごとに書くのでエッジで集める
			if e.kind_of? Sketchup::ConstructionLine
				pts[0] = e.start
				pts[1] = e.end
			elsif e.kind_of? Sketchup::Edge
				if e.curve == nil or bclass == "MWALL"
					pts[0] = e.start.position
					pts[1] = e.end.position 
				elsif curveids.index( e.curve.entityID ) == nil
					pts = e.curve.vertices.collect{|vt| vt.position }
					curveids.push e.curve.entityID
				end
			end
			if pts != []
				pts.each{|ptpt|
					allpts.push ptpt if allpts.find_all{|pt| pt == ptpt }.size == 0
				}
				#allpts.push pts[1] if allpts.find_all{|pt| pt == pts[1] }.size == 0
				if bclass == "STEEL_COLUMN" or bclass == "RC_COLUMN" or bclass == "RC_FOOTING"
				elsif bclass== "MWALL" or bclass == "RC_WALL"
					if pts.size > 2
						cgeom = drawStructure2( pts , beams_props )
					else
						if ppts != []
							if ppts[0] == pts[1] or ppts[1] == pts[0] or ppts[0] == pts[0] or ppts[1] == pts[1]
								cgeom = create_geometry2( pts , beams_props , pgeom )
							else
								cgeom = create_geometry2( pts , beams_props )
							end							
						else
							cgeom = create_geometry2( pts , beams_props )
						end
						ppts = pts
						pgeom = cgeom
					end
				else
					cgeom = drawStructure2( pts , beams_props )
				end
			end
		}
		#allpts.uniq!
		if @bclass == "STEEL_COLUMN" or @bclass == "RC_COLUMN"
			allpts.each{|apt|
				pts[0] = [ apt.x , apt.y , apt.z ]
				pts[1] = [ apt.x , apt.y , apt.z + beams_height ]
				cgeom = drawStructure2( pts , beams_props )
			}
		elsif @bclass == "RC_FOOTING"
			allpts.each{|apt|
				pts[0] = [ apt.x , apt.y , apt.z ]
				pts[1] = [ apt.x , apt.y , apt.z + 1000.mm ]
				cgeom = drawStructure2( pts , beams_props )
			}
		end
		Sketchup.active_model.commit_operation
	end
	def createSlabFromFace( ofc , t = Geom::Transformation.new , from_pt = false)
		if from_pt == false
			operation_name = "click to slab"
			if Sketchup.version.to_f < 7.0
				Sketchup.active_model.start_operation operation_name
			else
				Sketchup.active_model.start_operation operation_name,true
			end
		end
			@thickness = getLengthByUnits( @profile.split("-")[1] )
			if @thickness == 0.0
				p "No Thickness"
				return
			end
			eds = ofc.edges
			model = Sketchup.active_model
			ents = model.active_entities

			elist = []
			#elist.push fc
			ofc.edges.each{|ed| elist.push ed } 
			fcgrp = ents.add_group( elist )
			#t = Geom::Transformation.translation( Geom::Vector3d.new( 0,0, ( @slab_toplevel - @slab_hitlevel ) ) )
			fcgrp.transform! t
			fcgrp.entities.find_all{|e| e.kind_of? Sketchup::Edge }.each{|e2| e2.find_faces }

			fcgrp.entities.find_all{|e| e.kind_of? Sketchup::Face}.each{|e2|
				e2.material = add_new_material( @fmat ) if @fmat != ""
				e2.back_material = add_new_material( @bmat ) if @bmat != ""
			}
			fcgrp.entities.find_all{|e| e.kind_of? Sketchup::Face}.each{|e2|
				e2.pushpull @thickness
			}
			fcgrp.name = "#{@hugo}|#{@profile}"
			fcgrp.set_attribute "BEAM_SPECS","CLASS","SLAB"
			fcgrp.set_attribute "BEAM_SPECS","HUGO",@hugo
			fcgrp.set_attribute "BEAM_SPECS","PROFILE",@profile
			fcgrp.set_attribute "BEAM_SPECS","MATERIAL",@mat
			fcgrp.set_attribute "BEAM_SPECS","FL",@slab_toplevel
			
			killist = []
			eds.each{|ed| killist.push ed if ed.faces.size <= 1 }
			killist.push ofc
			ents.erase_entities killist
		Sketchup.active_model.commit_operation if from_pt == false
		return
	end
	def create_slab_withPT(  intpt , plane1 )
		operation_name = "click to slab"
		if Sketchup.version.to_f < 7.0
			Sketchup.active_model.start_operation operation_name
		else
			Sketchup.active_model.start_operation operation_name,true
		end

		model = Sketchup.active_model
		ents = model.active_entities

		grp = ents.add_group
		rad = model.bounds.diagonal * 2.0
		cen = model.bounds.center.project_to_plane( plane1 )
		cen = intpt

		cir = grp.entities.add_ngon( cen , [ 0.0 , 0.0 , 1.0 ] , @slab_hitrange , 4 )
		grp.entities.add_face cir
		intgrp = ents.add_group
		inttr = intgrp.transformation

		model.active_entities.intersect_with( true , Geom::Transformation.new , intgrp  , inttr , false , grp  )
		#intgrp.entities.add_face( intgrp.entities.find_all{|e| e.kind_of? Sketchup::Edge } )
		intgrp.entities.find_all{|e| e.kind_of? Sketchup::Edge }.each{|e2| e2.find_faces }
		grp.entities.erase_entities grp.entities.find_all{|e| e.kind_of? Sketchup::Face }

		killist = []
		killist.push grp
		killist.push intgrp
		fcs = intgrp.entities.find_all{|e| e.kind_of? Sketchup::Face }
		if fcs.size > 0
			
			fc2 = fcs.find_all{|fc| fc.classify_point( intpt ) == 1 }
			if fc2.size > 0
				t = Geom::Transformation.translation( Geom::Vector3d.new( 0,0, ( @slab_toplevel - @slab_hitlevel ) ) )
				createSlabFromFace( fc2[0] , t , true )
				ents.erase_entities killist
				Sketchup.active_model.commit_operation
				return true
			else
				#p "nothing"
				Sketchup.active_model.commit_operation
				Sketchup.undo
				return false
			end
		else
			Sketchup.active_model.commit_operation
			Sketchup.undo
			return false
		end
	end
	def label_hugo_text(grp , hugo , ipt )
		return nil if hugo == ""
		layers = Sketchup.active_model.layers
		layers.add "Structure-TAG-TEXT" if not layers["Structure-TAG-TEXT"]
		
		ents = grp.entities
		#hgrp = ents.add_group
		
		defs = Sketchup.active_model.definitions
		#path = File.join( File.dirname( File.expand_path(__FILE__) ), "bst_tag1.skp" )
		path = bst_file_join( bst_file_dirname( __FILE__ ), "bst_tag1.skp" )
		#Sketchup.find_support_file "bst_tag1.skp","plugins/building_structure_tool"
		df = defs["bst_tag1"]
		df = defs.load path if not df
		p "bst_tag1 loaded"
		t = Geom::Transformation.translation( [0,0,0].vector_to( ipt ) )
		ci = ents.add_instance df , t
		ci.layer = "Structure-TAG-TEXT"
		ci.explode.each{|e|
			if e.kind_of? Sketchup::Text
				e.text = hugo
				#e.visible = false
			end
			e.layer = "Structure-TAG-TEXT"
		}
		
		#hgrp.layer = "Structure-TAG-TEXT"
		#hgrp.explode
	end
	def label_dimw(grp , width , ipt )
		return nil if width == 0.0
		ents = grp.entities
		
		defs = Sketchup.active_model.definitions
		##path = File.join( File.dirname( File.expand_path(__FILE__) ), "bst_dimw1.skp" )
		path = bst_file_join( bst_file_dirname( __FILE__ ), "bst_dimw1.skp" )
		#Sketchup.find_support_file "bst_dimw1.skp","plugins/building_structure_tool"
		df = defs.load path
		t = Geom::Transformation.scaling( [0,0,0] , width / 100.mm )
		t = Geom::Transformation.translation( [0,0,0].vector_to( ipt ) ) * t
		ci = ents.add_instance df , t
		myset = []
		cents = ci.explode
		cents.each{|e|
			if e.kind_of? Sketchup::Edge
				myset.push e
			elsif e.kind_of? Sketchup::Drawingelement
				e.layer = "Structure_DimensionW"
			end
		}
		ents.erase_entities myset
	end
	def draw_hugo_text( grp , ipt , hugo , profile)
		return nil if hugo == ""
		layername = "Structure-TAG-TEXT"
		layers = Sketchup.active_model.layers
		layers.add layername if not layers[ layername ]
		
		ents = grp.entities
		tstr = hugo + "\n" + profile
		txt = ents.add_text( tstr , ipt )
		txt.layer = layers[ layername ]
		#hgrp = ents.add_group
		#hgrp.entities.add_3d_text hugo , TextAlignLeft , "Arial" , false, false, 120.mm , 0.2, 50.mm, true, 0.0
		#hgrp.material = "Black"

		###t = Geom::Transformation.scaling( [0,0,0] , 100 / 25.4 )
		#bbox = hgrp.local_bounds
		### ( - hgrp.bounds.width ) / 2 
		#t = Geom::Transformation.translation( [ 0,0,0 ].vector_to( [ - bbox.center.x , bbox.height * 3 , 0 ] ) )
		#hgrp.entities.transform_entities t , hgrp.entities.find_all{|e| e.kind_of? Sketchup::Face }
		#t = Geom::Transformation.rotation( [0,0,0] , [0,0,0].vector_to( [0,1,0] ), 180.degrees )
		#t = t * Geom::Transformation.rotation( [0,0,0] , [0,0,0].vector_to( [0,0,1] ), 180.degrees )
		#t = Geom::Transformation.translation( [0,0,0].vector_to( ipt ) ) * t
		#hgrp.transform! t
		#hgrp.name = "[TAG]#{hugo}"
		#hgrp.entities.each{|e|
		#	e.layer = layername
		#	if e.kind_of? Sketchup::Edge
		#		e.visible = false
		#	end
		#}
	end
	def add_new_material( mname = "" )
		mats = Sketchup.active_model.materials
		if mats[ mname ] == nil
			mat = mats.add mname
			mat.color = "white"
		else
			mat = mats[ mname ]
		end
		return mat
	end

end#module
end#module