# Name:   beams
# Description:draw beams shapes from list in text file.
# Copyright TAK2
###[NOTICE]]####
#Strongly Recommend Sketchup version 8 higher for using this.
#The copyright of this plug-in is in TAK2HATA. 
#Please use this plug-in in self-responsibility. 
#I do not take any responsibility. 
#You can use freely. 
#################


# Making based on Dline2(D.bur)
#v0.2:modified in 2011.01.26.
#選択ダイアログ部分
#2011/09/07 add prop wall width.
#2012/03/04 split function about dialog

module TAK2HATA::BuildingStrcutureTool
module TST1_mod_dialog
	##tool class##
		
        # Dialog
		def startDialogSelect( bclass = "STEEL_BEAM" )
			@bclass = bclass
			@wall_width = 100.mm
			if @bclass == "STEEL_COLUMN" or @bclass == "RC_COLUMN"
				@beams_just   = "Center"
				@beams_vjust   = "Middle"
				@beams_axis   = "Yes"
				@beams_fixz = ""
				@beams_spec   = ""
				#@beams_left  = 0.0 #  if @results[5] != 0.to_l
				@beams_top = 0.0
				@beams_height = 4000.mm
				@beams_rot = 0.0
				@beams_mirz = "No"
			
			elsif @bclass == "RC_WALL"
				@beams_just   = "Center"
				@beams_vjust   = "Bottom"
				@beams_axis   = "Yes"
				@beams_fixz = ""
				@beams_spec   = ""
				#@beams_left  = 0.0 #  if @results[5] != 0.to_l
				@beams_top = 0.0
				@beams_height = 4000.mm
				@beams_rot = 0.0
				@beams_mirz = "No"
				@wall_width = 100.mm
			elsif @bclass == "MWALL"
				@beams_just   = "Center"
				@beams_vjust   = "Bottom"
				@beams_axis   = "Yes"
				@beams_fixz = ""
				@beams_spec   = ""
				#@beams_left  = 0.0 #  if @results[5] != 0.to_l
				@beams_top = 0.0
				@beams_height = 4000.mm
				@beams_rot = 0.0
				@beams_mirz = "No"
				@wall_width = 100.mm
			else#if @bclass == "STEEL_BEAM" or @bclass == "RC_BEAM" or @bclass == "STEEL_GIRDER" or @bclass == "RC_GIRDER"
				@beams_just   = "Center"
				@beams_vjust   = "Top"
				@beams_axis   = "Yes"
				@beams_fixz = ""
				@beams_spec   = ""
				#@beams_left  = 0.0 #  if @results[5] != 0.to_l
				@beams_top = 0.0
				@beams_height = 0.0
				@beams_rot = 0.0
				@beams_mirz = "No"
			end
			#defaults = Sketchup.read_default("Structure Tool:#{@bclass}", "params")

			defaults = Sketchup.read_default("Structure Tool", "#{@bclass}:params")
			
				if not defaults
					tst_clear_class_default(@bclass)
					defaults = Sketchup.read_default("Structure Tool", "#{@bclass}:params")
				end
				if defaults
					@results = eval( defaults )
					if @results.size > 7
						@beams_just   = @results[0] if @results.size > 0
						@beams_vjust   = @results[1] if @results.size > 1
						@beams_axis   = @results[2] if @results.size > 2
						@beams_spec   = @results[3] if @results.size > 3
						@beams_mirz = @results[4] if @results.size > 4
						@beams_fixz = @results[5] if @results.size > 5
						#@beams_left  = @results[5].to_l if @results.size > 5
						@beams_top = @results[6].to_l if @results.size > 6
						@beams_height = @results[7].to_l if @results.size > 7
						@beams_rot = @results[8].to_f if @results.size > 8
						@wall_width = @results[9].to_l if @results.size > 9
					end
				end

			results = []
			if @bclass == "ALL"
				# when "ALL" selected,at the first time "Search Dialog" is shown.
				default = Sketchup.read_default("Structure Tool", "searchword")
				prompts = [langconv( "Search Word?(BLANK to ALL)" )]
				defaults = [default]
				results = UI.inputbox prompts, defaults, langconv( "Start from searching with Words?" )
				if results != nil
					default = results[0]
					Sketchup.write_default( "Structure Tool", "searchword", default )
					dialog( @bclass , @beams_spec , default )
				else
					dialog( @bclass , @beams_spec  )
				end
			else
				dialog( @bclass , @beams_spec  )
			end
			return [ @beams_just,@beams_vjust,@beams_axis,@beams_spec,@beams_mirz,@beams_fixz,@beams_top,@beams_height,@beams_rot,@wall_width ]
		end

        def dialog( bclass , beams_spec = ""  , utext = "" )
			pflist = []
			#TAG,PROFILE,FL,MATERIAL,Rotate,r1,r2
			#0:TAG:
				#As you like
				#...my recommend style is:"2G21" means G21 Girder on 2FL.
			#1:PROFILE:
				#like "H100x100x6x8"
				#like "SHS300x300x16"
				#like "CHS165.2x6"
				#like "L90x90x6"
				#like "C100x50x20x2.3
				#like "2[150x75x6.5x10"
				#like "RC400x800"
				#like "SRC500x800-H390x300x10x16"
				#like "FT1000x1000x300"
			#2:FL(Optional):Level of Top from Floor level.
				#like "+100" "-150" "0"
			#3:MATERIAL(Optional)
				#like "STEEL"
				#like "RC"
				#RC/Fc21
				#RC/Fc30
				#STEEL/SS400
				#STEEL/SN400C
				#STEEL/SN490C
				#STEEL/SM490A
				#STEEL/SN400B
				#STEEL/BCR295
			#4:Rotate:degrees
				#like 90
			 pflist , pflist_path = readProfiles( @bclass , utext )
			 
			if @bclass == "MWALL"###########################################MWALL
				#pdir = File.dirname( File.expand_path(__FILE__) ) + '/mwalls/*.skp'
				pdir = 'building_structure_tool/mwalls/*.skp'
				p pdir
				Dir::glob( pdir ).each {|f|
					#pflist.push "#{File.basename(f)}"
					pflist.push "#{bst_file_basename(f)}"
					#p File.basename(f)
				}
				pflist_path = pdir
			elsif pflist_path == false
				pflist.push "G1,H150x75x5x7,,SS400,0,,,"
				pflist.push "G2,H175x90x5x8,,SS400,0,,,"
				pflist.push "G3,H200x100x5.5x8,,SS400,0,,,"
				pflist.push "G4,H250x125x6x9,,SS400,0,,,"
				pflist.push "G5,H300x150x6.5x9,,SS400,0,,,"
				pflist.push "RG1,RC500x1200,,RC,0,,,"
				pflist_path = "Sample List"
			end
			
            @beams_just   = "Center" if not @beams_just
            @beams_vjust   = "Top" if not @beams_vjust
            @beams_axis   = "Yes" if not @beams_axis
			if @bclass == "MWALL"###########################################MWALL
				if @beams_spec == ""
					@beams_spec = pflist[0]
				elsif not pflist.index(@beams_spec)
					@beams_spec = pflist[0]
				end
			else			
				if @beams_spec == ""
					@beams_spec   = "0," + pflist[0]
				elsif not pflist.index(@beams_spec)
					@beams_spec   = "0," + pflist[0]
				else
					i = pflist.index( @beams_spec )
					@beams_spec = "#{i}," + @beams_spec
				end
			end
            @beams_left  = 0.0.m if not @beams_left
            @beams_top = 0.0.m if not @beams_top
			@beams_height = 0.0.m if not @beams_height
			@beams_rot = 0.0 if not @beams_rot
			@beams_fixz = "" if not @beams_fixz
			@beams_mirz = "No" if not @beams_mirz
			@wall_width = 100.0.mm if not @wall_width
			list_just=[ "Left","Center","Right" ].join("|")
			list_vjust=[ "Top","Middle","Bottom" ].join("|")
			list_axis=["Yes","No" ].join("|")
			pflist2 = []
			if @bclass == "MWALL"###########################################MWALL
				pflist2 = pflist
			else
				(pflist.size).times{|i|
					pf = pflist[i]
					#if pf[/^([^,]*),([^,]*),([^,]*),([^,]*),.*/]
					#	pflist2.push "#{i},#{$1},#{$2},#{$3},#{$4}"
					#end
					parr = pflist[i].split("\t")
					if parr.size >= 4
						pflist2.push "#{i},#{parr[0]},#{parr[1]},#{parr[2]},#{parr[3]}"
					end
				}
				bmarr = @beams_spec.split("\t")
				if bmarr.size >= 5
					@beams_spec = "#{bmarr[0]},#{bmarr[1]},#{bmarr[2]},#{bmarr[3]},#{bmarr[4]}"
				end
			end


			list_bspec = pflist2.join("|")
			
			prompts=["Justification:","Vertical Just:","Draw axis:","Beam Spec:","Mirror aboutZ:","Fix Z Input to(BLANK to Free)", "Top:", "Height:" , "Rotate:" ]
			prompts=prompts.map{|prp| langconv( prp ) }
			dropdowns=[list_just,list_vjust,list_axis,list_bspec,list_axis]
			values=[@beams_just,@beams_vjust,@beams_axis, @beams_spec , @beams_mirz ,@beams_fixz ,@beams_top,@beams_height,@beams_rot]	
			
			if @bclass == "ALL"
				dtitle = "#{langconv( 'Structure Tool' )}(#{langconv( 'ALL' )}):#{pflist_path}"
			elsif @bclass == "STEEL_BEAM" or bclass == "RC_BEAM"
				dtitle = "#{langconv( 'Structure Tool' )}(#{langconv( 'BEAM' )}):#{pflist_path}"
			elsif @bclass == "STEEL_GIRDER" or bclass == "RC_GIRDER"
				dtitle = "#{langconv( 'Structure Tool' )}(#{langconv( 'GIRDER' )}):#{pflist_path}"
			elsif @bclass == "RC_WALL"
				dtitle = "#{langconv( 'Structure Tool' )}(#{langconv( 'WALL' )}):#{pflist_path}"
				prompts.push "Wall Width override:"
				values.push @wall_width
			elsif @bclass == "MWALL"###########################################MWALL
				dtitle = "#{langconv( 'Structure Tool' )}(#{langconv( 'MWALL' )}):#{pflist_path}"
			elsif @bclass == "RC_COLUMN" or bclass == "STEEL_COLUMN"
				dtitle = "#{langconv( 'Structure Tool' )}(#{langconv( 'COLUMN' )}):#{pflist_path}"
			elsif @bclass == "RC_FOOTING"
				dtitle = "#{langconv( 'Structure Tool' )}(#{langconv( 'FOOTING' )}):#{pflist_path}"
			end
			results = []
			results=inputbox(prompts,values,dropdowns, dtitle )
			Sketchup.active_model.select_tool(nil) if (not results)
			return if not results
			@beams_just   = results[0] if results.size > 0
			@beams_vjust   = results[1] if results.size > 1
			@beams_axis   = results[2] if results.size > 2
			if results.size > 3
				if @bclass == "MWALL"###########################################MWALL
					beams_spec = results[3]
				else
					#beams_spec   = pflist[ results[3].split(",")[0].to_i ]
					@beams_spec   = pflist[ results[3].split("\t")[0].to_i ]
					results[3] = @beams_spec
					#beams_spec   = results[3]
				end
			end
			@beams_mirz = results[4] if results.size > 4
			@beams_fixz   = results[5] if results.size > 5
			
			@beams_top = results[6].to_l if results.size > 6
			@beams_height = results[7].to_l if results.size > 7
			@beams_rot  = results[8].to_f if results.size > 8
			@wall_width  = results[9].to_l if results.size > 9
			Sketchup.write_default("Structure Tool", "#{@bclass}:params", results.inspect.gsub( 34.chr , "'"))
        end

end # mod TSTBeams_Tool_withDialog
end#module

