# Copyright TAK2

require 'building_structure_tool/tst1_mod_extend_face_to_plane.rb'
#require 'building_structure_tool/tst1_mod_click_two_bst_entity.rb'
##Changed in 120904:Bugfix
module TAK2HATA::BuildingStrcutureTool
module TST1_extend_structures
	include TST1_mod_extend_face_to_plane
	def second_entity_clicked( ces , ps1 , ce2 , ps2 , exist_sels = false )
		operation_name = langconv("Extend Structure")
		if Sketchup.version.to_f < 7.0
			Sketchup.active_model.start_operation operation_name
		else
			Sketchup.active_model.start_operation operation_name,true
		end

		if exist_sels == true
			ces.each{|ce|
				tf1 = ce.transformation
				ps1 = ce.bounds.center
				extend_to_str_MS( ce , ps1 , ce2 ,true )
			}
		else
			ce = ces[0]
			extend_to_str_MS( ce , ps1 , ce2 , true )
		end
		Sketchup.active_model.commit_operation
	end
	def extend_to_str_MS( cform1 , ps1 , cform2 ,multi = false )
		return if cform2.get_attribute( "BEAM_SPECS","CLASS" ) == "MWALL"
		if cform1.get_attribute( "BEAM_SPECS","CLASS" ) == "MWALL"
			if multi == false
				operation_name = langconv("Extend Structure")
				if Sketchup.version.to_f < 7.0
					Sketchup.active_model.start_operation operation_name
				else
					Sketchup.active_model.start_operation operation_name,true
				end
			end
			
			cform1.entities.each{|ent|
				ent.make_unique
				extend_to_str_do( ent , ps1 , cform2 , cform1.transformation )
			}
			Sketchup.active_model.commit_operation if multi == false
		else
			if multi == false
				operation_name = langconv("Extend Structure")
				if Sketchup.version.to_f < 7.0
					Sketchup.active_model.start_operation operation_name
				else
					Sketchup.active_model.start_operation operation_name,true
				end
			end
			extend_to_str_do( cform1 , ps1 , cform2 )
			Sketchup.active_model.commit_operation if multi == false
		end
	end

	def extend_to_str_do( cform1 , ps1 , cform2 , ptf1 = Geom::Transformation.new( [0,0,0] ) )
	#@ce is current form 
	#@tf1 = @ip.transformation
	#@ps1 = @ip.position
	#@fc2 is extendto face
	#@tf2 = @ip.transformation
	#線形材の軸方向が平行な場合無駄なので終了する
	#線形材の幅を取り出す（Y方向が幅なのでheightで取り出すことになる
	tf1 = ptf1 * cform1.transformation
	tf2 = cform2.transformation
	clickpt_t = ps1.transform( tf1.inverse )#cform1座標内でのクリックした点の座標
	cform1 = cform1.definition if cform1.kind_of? Sketchup::ComponentInstance
	cform2 = cform2.definition if cform2.kind_of? Sketchup::ComponentInstance
	#まず　構造フォームの開始面と終了面を取り出す
	fc_start1 = get_startface( cform1 )
	fc_end1 = get_endface( cform1 )
	#fc_start2 = get_startface( cform2 )
	#fc_end2 = get_endface( cform2 )
	gr2bbmax , gr2bbmin = get_entitiesbounds( cform2.entities )
	#xvec1はペアレントの座標のベクトル
	xvec1 = Geom::Vector3d.new(1,0,0).transform(tf1)
	zvec1 = Geom::Vector3d.new(0,0,1).transform(tf1)

	#return if xvec1.parallel?(xvec2)

	xmin2 = gr2bbmin.x
	xmax2 = gr2bbmax.x
	ymin2 = gr2bbmin.y
	ymax2 = gr2bbmax.y
	zmin2 = gr2bbmin.z
	zmax2 = gr2bbmax.z

	#cform2との交点を求める
	#cform2のバウンディングボックスの６面を取り出す
	cfbb2 = []
	cfbb2[0] = [ [ xmin2 , ymin2 , zmin2 ] , [ xmin2 , ymax2 , zmin2 ] , [ xmin2 , ymax2 , zmax2 ] , [ xmin2 , ymin2 , zmax2 ] ]
	cfbb2[1] = [ [ xmax2 , ymin2 , zmin2 ] , [ xmax2 , ymax2 , zmin2 ] , [ xmax2 , ymax2 , zmax2 ] , [ xmax2 , ymin2 , zmax2 ] ]
	cfbb2[2] = [ [ xmin2 , ymin2 , zmin2 ] , [ xmax2 , ymin2 , zmin2 ] , [ xmax2 , ymin2 , zmax2 ] , [ xmin2 , ymin2 , zmax2 ] ]
	cfbb2[3] = [ [ xmin2 , ymax2 , zmin2 ] , [ xmax2 , ymax2 , zmin2 ] , [ xmax2 , ymax2 , zmax2 ] , [ xmin2 , ymax2 , zmax2 ] ]
	cfbb2[4] = [ [ xmin2 , ymin2 , zmin2 ] , [ xmax2 , ymin2 , zmin2 ] , [ xmax2 , ymax2 , zmin2 ] , [ xmin2 , ymax2 , zmin2 ] ]
	cfbb2[5] = [ [ xmin2 , ymin2 , zmax2 ] , [ xmax2 , ymin2 , zmax2 ] , [ xmax2 , ymax2 , zmax2 ] , [ xmin2 , ymax2 , zmax2 ] ]

	ipts1 = []
	ipl_index = []
	cnt = 0
	cnt2 = 0
	tvts = []
	tbb = fc_start1[0].bounds
	fc_start1[0].vertices.each{|vt1| tvts.push vt1.position }
	#fc_start1の判定の精度を上げる。
	cnt3 = 0
	tvts2 = []
	(0..2000).each{|tempcount|
		ttpt = (0..2).map{|tempcount2| (tbb.max[tempcount2] - tbb.min[tempcount2] ) * rand + tbb.min[tempcount2] }
		ttpt2 = ttpt.project_to_plane( fc_start1[0].plane )
		if Geom.point_in_polygon_2D( ttpt2 , tvts, true )
			tvts2.push ttpt2
			cnt3 += 1
		end
		break if cnt3 > 50
	}
	tvts2.each{|tvt2| tvts.push tvt2 }

	tvts.each{|pt1|
		#pt1 = vt1.position
		pt1.x = clickpt_t.x#クリックした点の座標からの測定
		pt1t = pt1.transform(tf1)#ペアレント座標での座標
		line1 = [ pt1t , xvec1 ]#ペアレント座標での線
		dist = 0.0
		cnt2 = 0
		chk = false
		#各バウディング面ごとに判定
		#面のインデックスごとに一番近い交点を判定
		cfbb2.each{|polypts2|
			ipt = intersect_onface( line1 , polypts2.map{|pt2| pt2.transform(tf2) } )
			if ipt != nil
				if dist > pt1t.distance(ipt) or chk == false
					#それぞれの面上に載る交点で近いものを選別する
					chk =true
					dist = pt1t.distance(ipt)
					ipts1[cnt] = ipt
					ipl_index[cnt] = cnt2
	#				UI.messagebox "#{cnt2}"
				end
			end
			cnt2 += 1
		}
		cnt += 1
	}

	#もっとも交点の多かった平面を交差判定用の平面として定義する
	cfsize = cfbb2.size - 1
	itemcount = 0
	polypts = []
	plane2 = fc_start1[0].plane
	(0..cfsize).each{|cnt|
		if itemcount < ipl_index.select{|i| i == cnt }.size
			itemcount = ipl_index.select{|i| i == cnt }.size
			polypts = cfbb2[cnt]
			plane2 = Geom.fit_plane_to_points polypts[0].transform(tf2),polypts[1].transform(tf2),polypts[2].transform(tf2)
	#		UI.messagebox "select plane is #{cnt}"
		end
	}
	return if plane2 == nil
	#開始面、終了面、クリック点からの延長線を定義
		spt = fc_start1[0].vertices[0].position.transform(tf1)
		ept = fc_end1[0].vertices[0].position.transform(tf1)
		ppt = ps1
		sline = [ spt , xvec1 ]
		eline = [ ept , xvec1 ]
		pline = [ ppt , xvec1 ]

	#それぞれの交点を求める
		ipt_s = Geom.intersect_line_plane(sline, plane2)
		ipt_e = Geom.intersect_line_plane(eline, plane2)
		ipt_p = Geom.intersect_line_plane(pline, plane2)

		return if ipt_s == nil or ipt_e == nil or ipt_p == nil
	#それぞれの延長距離
		dist_s = ipt_s.distance( spt )
		dist_e = ipt_e.distance( ept )
		dist_p = ipt_p.distance( ppt )
		vec_s = spt.vector_to( ipt_s )
		vec_e = ept.vector_to( ipt_e )
		vec_p = ppt.vector_to( ipt_p )
	#fc1に移動すべき面を代入する
		modpos = "start"
	#既に延長先に接している場合
		if vec_s.length == 0
			fc1 = fc_start1
		elsif vec_e.length == 0
			fc1 = fc_end1
			modpos = "end"
		elsif vec_p.length == 0
			fc1 = fc_end
			modpos = "end"
		elsif vec_s.samedirection?( vec_p ) and vec_e.samedirection?( vec_p )
			if dist_s < dist_e
				fc1 = fc_start1
			else
				fc1 = fc_end1
				modpos = "end"
			end
		elsif vec_s.samedirection?( vec_p )
			fc1 = fc_end1
			modpos = "end"
		else
			fc1 = fc_start1
		end

		grp = fc1[0].parent
		
	#fc1の属するグループの座標系の中で交点計算をしないで、交点を逆算する

		xvec = Geom::Vector3d.new(1,0,0)
		#fc1.each{|fc|
		#	extend_do( cform1 , fc , tf1 , plane2 , xvec )
		#}
		extend_do_fcs( cform1 , fc1 , tf1 , plane2 , xvec , modpos )
		#modify_cline( grp , tf1 , modpos , xvec , plane2 )
		#Sketchup.active_model.commit_operation

	end

end # of class

end#module