module TAK2HATA::BuildingStrcutureTool
module TST1_mod_toolclass
        def reset(view)
            @pts              = []
            @shape_pts         = []
            @state            = 0
            @drawn            = false
            @ip.clear
            @ip1.clear
            @ip2.clear
            Sketchup::set_status_text langconv( "First point or Search Keyword" )
            view.lock_inference if view
        end
        def reset2(view)
			pt = @pts[1]
			@ip1 = Sketchup::InputPoint.new( @pts[1] )
            @pts = []
			@pts.push pt
            @shape_pts         = []
            @state            = 1
            @drawn            = false
            @ip.clear
			
            #@ip1.clear
            @ip2.clear
            Sketchup::set_status_text langconv( "First point or Search Keyword" )
            view.lock_inference if view
        end
        def resume(view)
            if @state == 0
                Sketchup::set_status_text langconv( "First point" )
            end
        end
        def deactivate(view)
            view.invalidate if @drawn
            #Sketchup.active_model.options[0]["LengthSnapLength"]=@old_snap
            #values=[@beams_just,@beams_axis,@beams_width.to_f,@beams_height.to_f]
            #Sketchup.write_default("Structure Tool:#{@bclass}", "params", values.inspect.gsub(34.chr, "'"))
        end

        def onCancel(flag, view)
            # Clean view and exit the tool
            view.invalidate if @drawn
			if ( @bclass == "RC_WALL" or @bclass == "MWALL" ) and @state == 1
				@pgeom = nil
				self.reset(view)
			else
				Sketchup.active_model.select_tool nil
			end
        end

        def onReturn(view)
            # Clean view and exit the tool
            view.invalidate if @drawn
            self.reset(view)
            Sketchup.active_model.select_tool nil
		end
		
        def drawBeam(view)

			operation_name = langconv( "draw structure" )
			if Sketchup.version.to_f < 7.0
				Sketchup.active_model.start_operation operation_name
			else
				Sketchup.active_model.start_operation operation_name,true
			end


			pgeom = self.create_geometry( @bclass , @pts , @beams_spec , @beams_just , @beams_vjust , @beams_axis , @beams_top , @beams_rot , @beams_mirz , @wall_width , @beams_height , @pgeom)
			#Sketchup.active_model.commit_operation
			@pgeom = pgeom
			#Sketchup.active_model.commit_operation
			if @bclass == "RC_WALL" or @bclass == "MWALL"
				self.reset2(view)
			else
				self.reset(view)
			end
		end

        def onRButtonDown(flags, x, y, view)
            dialog()
            view.invalidate
			#onReturn(view)
        end

        def onUserText(text, view)
            if @state == 0
                # enter hariHugo
                dialog text
            end
			
            return if not @state == 1
            return if not @ip2.valid?

            #if text != "c" and text != "C"
                begin
                    value = text.to_l
                rescue
                    # Error parsing the text
                    UI.messagebox( "#{text} " + langconv( "cannot convert to a Length" ) )
                    value = nil
                    Sketchup::set_status_text "", SB_VCB_VALUE
                end
            return if !value
			#end
            # Compute the direction and the second point
            if ( @state == 1 )            
	            #pt1 = @ip1.position
				pt2 = @ip2.position
				pt2.z = @beams_fixz.to_l if @beams_fixz != ""
				vec = @pts[0].vector_to(pt2)
                if vec.length == 0.0
	            #vec = @ip2.position - pt1
	            #if( vec.length == 0.0 )
	                UI.messagebox( langconv("Zero length invalid !") )
	                return
	            end
	            vec.length = value
	            pt2 = @pts[0] + vec
	            # Store point
	            @pts.push(pt2)

            	#@ip1 = Sketchup::InputPoint.new( @pts[1] )
				drawBeam( view )
            end
            view.invalidate

            # This point becomes initial point
            #@ip1.copy! @ip2
            #@ip1= Sketchup::InputPoint.new(pt2)
        end

        def onMouseMove(flags, x, y, view)
            if( @state == 0 )
                Sketchup::set_status_text langconv("First point")
                # Getting the first end
                @ip.pick view, x, y
                if( @ip != @ip1 )
                    # if the point has changed from the last one we got
                    view.invalidate if( @ip.display? or @ip1.display? )
                    @ip1.copy! @ip
                    # set the tooltip that should be displayed to this point
                    view.tooltip = @ip1.tooltip
                end
            else
                # Getting the next end
                Sketchup::set_status_text langconv("Next point:[Esc]=Quit")
                Sketchup::set_status_text langconv("LENGTH"), SB_VCB_LABEL
                @ip2.pick view, x, y, @ip1

                # Update the length displayed in the VCB
                if( @ip2.valid? )
                    length = @ip1.position.distance(@ip2.position)
                    Sketchup::set_status_text length.to_s, SB_VCB_VALUE
                end

                view.tooltip = @ip2.tooltip if( @ip2.valid? )
                view.invalidate
            end
        end

        def onLButtonDown(flags, x, y, view)

            if ( @state == 0 )
                #check first point
                if( @ip1.valid? )
                    # Store point
                    @pts.push(@ip1.position)
					@pts[0].z = @beams_fixz.to_l if @beams_fixz != ""
					@ip1 = Sketchup::InputPoint.new( @pts[0] )
					if @bclass == "STEEL_COLUMN" or @bclass == "RC_COLUMN"
						@pts.push( [ @pts[0].x , @pts[0].y , @pts[0].z + @beams_height ] )
						#@pts.push( [ @ip1.position.x , @ip1.position.y , @ip1.position.z + @beams_height ] )
						drawBeam( view )
					elsif @bclass == "RC_FOOTING"
						@pts.push( [ @pts[0].x , @pts[0].y , @pts[0].z + 1000.mm ] )
						#@pts.push( [ @ip1.position.x , @ip1.position.y , @ip1.position.z + 1000.mm ] )
						drawBeam( view )
					else
						@state+=1
					end
                end
            end
            if ( @state == 1 )
                #check next point
                if( @ip2.valid? )
					pt2 = @ip2.position
					pt2.z = @beams_fixz.to_l if @beams_fixz != ""
                    # Store point
                   # if @pts[0].vector_to(@ip2.position).normalize.length > 0
                    if @pts[0].vector_to(pt2).normalize.length > 0
	                    @pts.push(pt2)
						#@pts[1].z = @beams_fixz.to_l if @beams_fixz != ""
						#@ip1 = Sketchup::InputPoint.new( @pts[1] )
	                    # This point becomes initial point
	                    #@ip1.copy! @ip2
						drawBeam( view )
					end
                end
            end
            view.invalidate
        end
        
        # Draw temp line between ends of partition axis
        def draw_temp_line(pt1, pt2, view)
            #view.drawing_color = "red"
            view.set_color_from_line(pt1, pt2)
            #view.line_stipple="-.-"
            if view.inference_locked?
                view.line_width=2
            end
            @bbp = [pt1, pt2]
            view.draw_line(pt1, pt2)
        end

        def getExtents
            bb = Geom::BoundingBox.new
            #bb.aptsdd(pt) if pt
            if @bbp
            @bbp.each { |pt| bb.add(pt) }
            end
            bb
        end

        def onKeyDown(key, rpt, flags, view)
            if( key == CONSTRAIN_MODIFIER_KEY )
                # if we already have an inference lock, then unlock it
                if( view.inference_locked? )
                    view.lock_inference
                elsif( @state == 1 )
                    ##view.lock_inference @ip2, @ip1##110909
					p "state1"
                    view.lock_inference @ip2 , @ip
                else
					p "state"
                    view.lock_inference @ip2
                end
                view.invalidate
            end
        end

        def onKeyUp(key, rpt, flags, view)
            if( key == CONSTRAIN_MODIFIER_KEY && view.inference_locked? )
                #(Time.now - @shift_down_time) > 0.5 )
                view.lock_inference
            end
            if key == 9 # or key == 15 or key == 48 # Tab key (according to TIG) ?
                dialog()
            end
            view.invalidate
        end
		
        def draw(view)
            # Show input points when valid
            if( @ip1.valid? )
                if( @ip1.display? )
                    @ip1.draw(view)
                    #@drawn = true
                end  
                if( @ip2.valid? )
                    @ip2.draw(view) if( @ip2.display? )
                    self.draw_temp_line(@ip1.position, @ip2.position, view) if (@ip1.valid? and @ip2.valid?)
                    #@drawn = true
                end
            end
            # Show the previously drawn axis
            #self.draw_previous_points(view)
            @drawn = true
        end

end#module
end#module
